*** WooCommerce Smart Coupons Changelog ***

2026-06-25 - version 9.79.0
* New: Tested up to WordPress 7.0.0
* New: Tested up to WooCommerce 10.8.1
* New: Added the Quick Start Sell Gift Card feature.
* Fix: Datepicker conflicts with third-party plugins and unnecessary datepicker script loading on non-gift certificate product pages
* Fix: Auto apply programmatically generated coupons do not apply until coupon is manually re-saved
* Fix: Fixed Cart Discount coupons restricted by taxonomy were being incorrectly rejected
* Update: Added data in the 'discount_type' column in supported format in the sample.csv file
* Update: Highlighted fields & features added by the plugin for better clarity
* Update: Translations

2026-05-28 - version 9.78.0
* New: Tested up to WooCommerce 10.8.0
* Fix: URL coupon compatibility issue with Affiliate for WooCommerce pretty links and Smart Coupons pretty links
* Fix: Select Fields Broken on Coupon Add, Edit, and Bulk Generate Tabs on the Admin Side
* Fix: Admin Coupon Shareable Link Metabox UI/UX Issues
* Fix: Improvement to prevent the site from crashing
* Fix: Resolved an issue where inconsistent tax settings were not working as expected with Store Credits
* Fix: Improved unused coupon reminder expiry validation with timezone-safe handling and support for both UNIX timestamp and datetime expiry formats
* Update: Re-enabled the 'Insights' dashboard widget with performance, caching, and UI improvements
* Update: Translations

2026.05.02 - version 9.77.0
* New: Tested up to WooCommerce 10.7.0
* Fix: MySQL treats double-quoted strings as identifiers (column/table names) rather than string literals when ANSI_QUOTES is enable
* Fix: Coupon Max discount was miscalculated when coupon has gift product
* Fix: Coupon with 'For new customers?' enabled, unable to validate repeat guest users when paid with PayPal payment gateway from [WooCommerce PayPal Payments](https://wordpress.org/plugins/woocommerce-paypal-payments/)
* Fix: Gift receiver data overwrite when multiple cart items or variations share the same coupon, ensuring correct data mapping per item
* Fix: Gift card scheduling issue when using different languages
* Fix: Importing coupons causes an issue when HEX characters are present in the CSV file
* Update: Translations

2026.04.08 - version 9.76.0
* New: Tested up to WooCommerce 10.6.2
* Fix: Errors occurring during subscription renewals
* Fix: Coupon data is being saved incorrectly, leading to major performance problems across admin edit product
* Update: Translations

2026.04.02 - version 9.75.0
* Fix: Checkout WC Side cart not updating free product
* Fix: Database compatibility issue with MySQL server using ANSI_QUOTES
* Update: Temporarily disabled analytics dashboard widget
* Update: Translations

2026.03.27 - version 9.74.1
* Fix: Removed unsupported "IF NOT EXISTS" from CREATE TABLE query to ensure compatibility with dbDelta and prevent SQL warnings
* Update: Translations

2026.03.26 - version 9.74.0
* New: Tested up to WordPress 6.9.4
* New: Tested up to WooCommerce 10.6.1
* New: Capture coupon configuration snapshot at order level in a dedicated lookup table (`wc_sc_order_coupon_meta_lookup`) for analytics and future reporting, with optimized DB version-aware table creation
* Fix: Resolved a JavaScript error occurring when 'wp.plugins.registerPlugin' was unavailable on block based checkout
* Fix: URL coupon handling now correctly applies each coupon instead of reusing the last code
* Fix: Malformed logic guard affecting gift coupon amount calculation
* Fix: Standardized precision units for coupon validation in admin orders
* Fix: Applied correct discount for coupon action products in admin orders
* Fix: Auto apply coupon not working as expected with product categories
* Fix: Slow cart page and duplicate coupon notice in WPML/WCML plugin compatibility
* Fix: Avoided unnecessary WooCommerce session creation on non-gift product pages
* Fix: Coupon validation for product attributes now correctly applies only to matching variations instead of all variations of the same parent product
* Developer: Introduced a new filter wc_sc_coupon_details_to_be_sent that allows developers to customize the title text of the 'Send Coupon' form
* Update: Translations

2026.03.07 - version 9.73.1
* Fix: PHP notices for undefined 'days', 'time', 'time_taken_by_wc', 'coupon_generated', 'coupon_emailed'
* Tweak: Make sure to include preset templates safely
* Update: Some labels related to 'Quick Preset' feature
* Update: Styles of drop down button of 'Quick Preset' feature
* Update: Translations

2026.03.07 - version 9.73.0
* New: Tested up to WooCommerce 10.5.3
* New: Added a "Revenue Insights" dashboard widget to display key performance metrics for Smart Coupons, including store credit used, orders created using store credit, and additional revenue from coupon
* New: Added "Automation Impact" dashboard widget to display Person hours saved, number of auto-generated coupons & number of emails sent automatically by the plugin
* New: Added a quick action to quickly setup 'BOGO' coupon
* Fix: Product category restrictions for Store Credit were not applied correctly when creating or updating manual orders from the admin
* Update: Improved French language translations strings
* Update: Translations

2026.02.26 - version 9.72.0
* New: Tested up to WooCommerce 10.5.2
* Fix: Coupons were not importing metadata correctly for translated discount types in CSV
* Developer: Added wc_sc_cart_totals_coupon_html filter for customizing cart totals coupon HTML
* Update: Minor CSS tweaks for the 'Welcome' page
* Update: Translations

2026.02.12 - version 9.71.0
* New: Tested up to WordPress 6.9.1
* New: Tested up to WooCommerce 10.5.1
* New: Updated 'Welcome' & 'About' page on the admin side
* Fix: Available coupons are not displaying due to inconsistent tax settings
* Update: Added support for pretty permalinks using the 'sc-page' endpoint to accept coupons from the URL
* Update: Compatibility for WooPayments Multi-Currency for displaying discounts & coupon amount in active store currency
* Update: Translations

2026.01.29 - version 9.70.0
* Fix: Crossed discount and subtotal values not matching correctly in the cart
* Fix: 'Send Coupons' form value not updating when an amount for the gift card is changed from the variable amount dropdown menu
* Fix: Improvement in checking condition for '$receiver_details' using '! empty()' to prevent potential warnings
* Update: WPML Compatibility prevents product discount removal when the site language is switched
* Update: Translations

2026.01.22 - version 9.69.0
* Fix: Coupon minimum and maximum amount validation to correctly use the subtotal when prices are displayed inclusive of tax
* Fix: Auto-generated Cashback Rewards credits not respecting the store decimal precision settings
* Fix: Gift Card coupons not generated and emails not sent when using a block-based Cart page with a classic Checkout page
* Fix: Safeguard WooCommerce session initialization to prevent REST API fatal errors
* Update: Improved French language translations strings
* Update: Translations

2026.01.15 - version 9.68.0
* Fix: Conflict with Breakdance plugin causing the 'Send Coupon' form not to appear on the product page
* Update: Translations

2026.01.08 - version 9.67.0
* Fix: Cashback Rewards 'Combine Emails' option not sending the auto-generated email template when enabled
* Fix: Store Credit coupons generating incorrectly for multiple quantities when paid via Apple Pay or Google Pay
* Fix: Incorrect discount calculation in admin orders when the 'Apply Before Tax' option is enabled
* Fix: Coupons not respecting the maximum discount limit when applied to bundle products
* Fix: Undefined variable notice for $minimum_amount_rounded
* Fix: Array-to-string conversion warning
* Fix: Undefined array key notice for "line_subtotal"  & "enabled"
* Fix: Improvements to the 'smart_coupon_countdown' shortcode
* Update: Replaced text labels with icons for coupon actions on the Coupons Dashboard
* Update: Changed column names and field names on the Coupons Dashboard
* Update: Merged Allowed Emails, Excluded Emails, and Issued Amount into a single column, "Smart Coupons' meta data"
* Update: Translations

2026.01.03 - version 9.66.0
* New: Shortcode 'smart_coupon_countdown' for displaying countdown timers about coupon expiry, also works with banners provided by the plugin
* New: Display Store Credit balance getting used from the total balance available, alongside coupon codes on Cart and Checkout page
* New: Display original price of the product as crossed along with discounted price of the product in the cart
* Fix: A product that issues store credit, is not getting added to cart when it is set as gift product under a coupon's Actions tab
* Fix: Max discount not getting applied when coupons are applied to orders from the admin side
* Fix: Incorrectly setting the default quantity as 1 for the product that is not there in the cart
* Developer: Added 'wc_sc_coupon_show_store_credit_balance' filter to enable or disable Store Credit balance display
* Developer: Added 'wc_sc_store_credit_balance_label' filter to customize the Store Credit balance label
* Update: Translations

2025.12.25 - version 9.65.0
* New: Tested up to WooCommerce 10.4.3
* New: Customers can now enter recipient details, personalized messages, and schedule delivery of coupons directly from the product page (only for shortcode-based checkout page)
* New: Display promotion-like messages on the product page for product-based discounts
* Fix: Cashback Rewards not generating store credit coupons when HPOS was enabled without WP posts sync due to order meta not being detected
* Fix: Empty lines in CSV files causing the import process to stop
* Fix: Coupon application & discount calculation getting affected due to issue with the inclusive of tax and minimum amount
* Developer: Added filter 'sc_gift_ignore_sanitize_receiver_message' to not avoid line break of receiver email template
* Developer: Added filters 'wc_sc_show_product_page_gift_form' and 'wc_sc_gift_form_default_accordion_state' to enable/disable form and manage accordion default state
* Update: Translations

2025.12.11 - version 9.64.0
* New: Tested up to WordPress 6.9.0
* New: Tested up to WooCommerce 10.3.6
* Fix: Gift products were not added correctly when applying coupons through custom AJAX request
* Fix: Fatal error when modifying shipping methods with invalid value
* Fix: Coupon error messages were being replaced unexpectedly
* Fix: Fixed product discount coupons were not applying correctly when creating orders are created manually from admin side
* Fix: Store Credit coupons are not generating when the order is being paid using Apple Pay or Google Pay
* Update: Replaced deprecated 'wc_enqueue_js()' usage for compatibility with WooCommerce 10.4
* Update: Translations

2025.11.27 - version 9.63.0
* New: Tested up to WooCommerce 10.3.5
* Fix: Products set under 'Actions' tab is not considering tax settings, causing invalidation of coupon spend limit
* Fix: Coupon scheduling not setting correct time when scheduled from shortcode-based checkout page
* Fix: Coupon meta not updating
* Fix: Coupons restricted to product, when applied via URL coupons, not applying & redirecting to home page
* Fix: Treating everything passed in the URL as coupons, causing performance issues
* Fix: URL coupons redirects to the same page when the page slug and coupon code are the same
* Fix: Coupon applied via URL not showing in CheckoutWC Side Cart on first load due to timing issue
* Update: Label & descriptions of some of the fields of Cashback Rewards settings
* Developer: Added filter 'sc_shareable_link_url' to customize coupon URL

2025.11.07 - version 9.62.0
* New: Added REST API endpoint to retrieve detailed store credit and available coupons for authenticated users
* Fix: Error in cart for auto apply coupon for subscription variable product
* Fix: Product meta for image upload not saving properly
* Developer: Added filters 'wc_sc_unused_coupon_reminder_coupon_ids' and 'wc_sc_unused_reminder_email_coupon' to modify coupon IDs and coupon object before sending unused reminder emails
* Tweak: Some additional checks to prevent running unnecessary code on the product edit page on the admin side
* Update: Moved shortcode 'wc_sc_balance' and 'smart_coupons_balance' to run with hook 'init'
* Update: Moved error logging for feature of image upload from system level logging to error logging of the plugin
* Update: Translations

2025.11.01 - version 9.61.1
* Fix: Uncaught Error: Class 'WC_SC_Email' not found
* Update: Restricted some code execution from the places where it's not required
* Update: Translations

2025.10.30 - version 9.61.0
* New: Tested up to WooCommerce 10.3.3
* New: Issue a new coupon for every new order that matches a specified criteria
* Fix: Attribute-based exclusions not working consistently with variable products
* Fix: Excluded products added from 'Actions' tab from the calculation of subtotal for Usage restrictions 'Minimum spend' and 'Maximum spend'
* Update: Copy email notifications settings from 'Emails' tab to 'Smart Coupons' tab under 'WooCommerce > Settings'
* Update: Use of store credit label in email notification setting for 'Store Credit email with image'
* Update: Translations

2025.10.23 - version 9.60.0
* New: Tested up to WooCommerce 10.3.0
* New: Display notices on the cart & the checkout page about additional action to perform for an offer like discount or free shipping
* Fix: Restrict guest users from viewing and applying role-restricted coupons during checkout
* Fix: Expired coupons were being incorrectly selected in the 'Unused Coupon Reminder' query when expiry reminders were enabled or disabled
* Update: Translations

2025.10.16 - version 9.59.0
* Fix: When 'Give to someone else' is selected on block-based checkout page, gift card emails were sent to the admin instead of the recipient's email address
* Fix: Compatibility with CheckoutWC where 'Available Coupons' appeared on checkout despite being disabled in settings
* Fix: URL Coupons redirecting visitors to the homepage
* Update: Made the gift card image upload process more reliable
* Update: Translations

2025.10.09 - version 9.58.0
* New: Coupons were not showing in the "Available Coupons" section after being removed from Auto Apply
* Fix: Auto-generated coupon emails used the gift card template even when product image upload was disabled
* Fix: Sender message not appearing in gift card recipient email after switching to gift-card-email.php template
* Fix: Translation support for the word 'percent' in the coupon actions tab for products
* Fix: Store Credit usage restriction not excluding product brands correctly
* Fix: Attribute restrictions not working for auto-applied coupons
* Update: Translations

2025.10.07 - version 9.57.0
* New: Tested up to WordPress 6.8.3
* New: Feature 'Unused Coupon Reminder' email to automatically notify customers about their coupons that are unused for a specified duration
* Fix: Fatal error in WC_SC_Gift_Card_Image::display_order_item_meta by making the 4th parameter optional when 'woocommerce_order_item_meta_end' passes only 3 arguments
* Update: Translations

2025.10.02 - version 9.56.0
* New: Tested up to WooCommerce 10.2.2
* New: Shortcodes 'wc_sc_balance' and 'smart_coupons_balance' to show store credit balance
* Fix: Prevent coupon category archive pages from non-admin users by redirecting them to shop page
* Fix: Prevent auto-generation of coupons during subscription switching to avoid granting coupons without payment
* Fix: Unnecessary loading of some JavaScript and CSS on pages where they are not required
* Fix: Improved plugin reliability by enhancing exception handling
* Developer: Filters 'sc_coupon_category_should_redirect' and 'sc_coupon_category_redirect_url' added for customizing URL coupon behavior
* Update: Accept coupon from URL even if it is passed like endpoint or pretty permalinks
* Update: Translations

2025.09.24 - version 9.55.0
* New: Added support for gift card image uploads, allowing customers to upload an image to personalize their gift cards
* Update: Translations

2025.09.10 - version 9.54.0
* Fix: Coupons are not auto-generating when 'Apple Pay' is used to pay for the order
* Fix: Error in Danish translation strings that caused fatal error with unknown format specifier '&'
* Fix: Translation issue with coupon action's gift product message so it now displays correctly in all languages
* Fix: Coupons set to 'First Order Only' were incorrectly applied to registered users who had previously purchased as guests
* Fix: Gift Card not added via AJAX when using 'WPC AJAX Add to Cart for WooCommerce' plugin
* Update: Improvements in usage restriction based on number of orders like default values, arguments in filter 'wc_sc_coupons_by_order_count_statuses' and 'wc_sc_coupons_by_order_count_error_message', use of CRUD-based meta functions for better consistency
* Update: Translations

2025.09.03 - version 9.53.0
* Fix: Validated coupon quantities to prevent automatic application under unexpected cart conditions
* Update: Translations

2025.09.01 - version 9.52.0
* New: Coupon restrictions - 'Number of orders made' to limit coupon usage based on the customer's completed orders
* Update: Improved file inclusion method using WordPress functions
* Update: Migrated class 'SA_WC_Compatibility_4_4' to 'SA_WC_SC_Compatibility'
* Update: Translations

2025.08.28 - version 9.51.0
* New: Tested up to WooCommerce 10.1.2
* Fix: Incorrect discount amount shown in admin order email
* Fix: Improved plugin reliability by enhancing exception handling
* Update: Translations

2025.08.22 - version 9.50.0
* New: Tested up to WooCommerce 10.1.1
* Fix: Coupon code case sensitivity issue causing compatibility problems with other plugins
* Update: Translations

2025.08.18 - version 9.49.0
* Fix: Gift product not added to the cart when 'FunnelKit Cart for WooCommerce' plugin is enabled
* Fix: Improved plugin reliability with better exception handling
* Update: Translations

2025.08.07 - version 9.48.0
* Fix: Auto-generated coupon details were not displaying in the order confirmation email
* Fix: Translation issue in the email header when the customer receives the email from the plugin
* Fix: 'Generated coupons' section on order admin shows all older coupons
* Fix: Broken CSS for text 'And' under 'Coupon data > Usage restriction' with WooCommerce version 9.6.2 & lower
* Developer: Filter 'wc_sc_email_coupon_description_text' to manage display for email coupon description text
* Update: Translations

2025.07.31 - version 9.47.0
* Fix: Free product from "Actions" tab not added to cart when applying coupon causes page reload
* Fix: Improved UI scripts for the "Available Coupons" section
* Fix: Shortcode-based "Available Coupons" section will no longer follow hide settings of collapsible "Available coupons" section
* Fix: Settings "Always show section" and "Open by default" are now always visible
* Fix: "Preview email" styles no longer affect the entire admin page ["Bulk Generate" & "Send store credit" tab]
* Update: Translations

2025.07.28 - version 9.46.0
* New: Tested up to WooCommerce 10.0.4
* Fix: {coupon_type} merge tag doesn't work in the Acknowledgement email
* Fix: Updated combined coupon validation to allow unspecified combinations by default
* Fix: Improved conditional check for `$subtotal` using `! empty()` to prevent potential warnings and improve code reliability
* Update: Translations

2025.07.23 - version 9.45.2
* Fix: Corrected SQL error caused by unset $subtotal in amount conditions
* Update: Translations

2025.07.22 - version 9.45.1
* New: Tested up to WooCommerce 10.0.3
* Fix: Added checks to prevent fatal errors in some cases
* Update: Translations

2025.07.21 - version 9.45.0
* New: Tested up to WordPress 6.8.2
* New: Tested up to WooCommerce 10.0.2
* Fix: Sender and receiver details now visible in 'More Details' on My Account > Coupons
* Fix: Showing coupon validation notice when not required
* Fix: Resolved translation issue in checkout related to incorrect handling of single quotes in localized strings
* Fix: Improved layout in the "Send Store Credit" tab
* Fix: Discount amount in admin order email now reflects accurate value
* Fix: Prevented JS error in French by escaping inline translations with `esc_js()`
* Fix: On the plugin's admin setting page, footer notes are overlapping the 'Save changes' button
* Fix: Wrong escaping function, using 'esc_attr__()' in a context outside of HTML attributes
* Update: Improved handling of adding products to the cart via AJAX in the Coupon Action tab [Admin]
* Update: Translations

2025.07.15 - version 9.44.0
* Update: Prevent coupon generation overlap when multiple admins run bulk generation simultaneously
* Fix: Added CheckoutWC compatibility file to resolve integration issues
* Fix: Auto-apply coupons no longer disappear during checkout transition
* Fix: Optimized background AJAX call frequency to improve performance and reduce server load
* Fix: Illegal string offset ‘global_coupons’
* Fix: Array to string conversion warning
* Fix: PHP Fatal error: translations on Swedish language
* Update: Translations

2025.07.04 - version 9.43.0
* New: Settings to manage the display of 'Available coupons' section on the Cart & the Checkout page
* Fix: Double display of coupon application success notification triggered by auto-apply coupons
* Fix: Store Credit coupon amount not deducting correctly when coupon code case did not match
* Fix: Case sensitivity in coupon code handling causing incorrect behavior on orders admin pages
* Update: Improvements in 'Available coupons' section on the cart & the checkout page like smooth loading & transitions
* Update: Improved compatibility with WooCommerce's case-sensitive coupon validation logic
* Update: By default, store credit will not reduce line total & line taxes
* Developer: Filter hook 'wc_sc_store_credit_reduce_line_totals' to control whether store credit will reduce the line total & line taxes or not
* Update: Translations

2025.06.27 - version 9.42.0
* New: Tested up to WooCommerce 9.9.5
* Fix: Improved data migration logic to ensure reliable batch processing into `wc_smart_coupons` custom table
* Fix: Emails sent from the plugin now respects the case defined in custom label set for discount type 'Store credit' and no longer forces lowercase
* Fix: Improved UI/UX of coupon Usage restrictions and separated multiple include/exclude settings for better clarity and control
* Update: Replaced Chosen.js with Select2 for Usage restriction > 'Allowed locations' to improve performance and support asynchronous data loading
* Update: Translations

2025.06.19 - version 9.41.0
* New: Tested up to WooCommerce 9.9.4
* New: Swedish, Danish & Korean translations (AI-generated)
* Fix: Bulk-generated coupons were imported with an incorrect author
* Fix: Issue where multiple notices were displayed and Action tab-related products remained in the checkout after coupon removal
* Fix: Available coupons were not displaying on the checkout page when using the CheckoutWC plugin
* Fix: Auto Apply coupon with Individual use set is causing infinite loop
* Update: Translation

2025.06.16 - version 9.40.0
* New: Tested up to WooCommerce 9.9.3
* New: Polish, Turkish & Portuguese(Brazil & Portugal) translations (AI-generated)
* Fix: Improved SQL logic to avoid partial matches in product exclusion for Auto Apply coupons
* Fix: Persistent "Display message to user" after coupon/product removal
* Fix: Layout issue in "Send Store Credit" tab
* Fix: New Customer Discount not applying on guest checkout
* Fix: Store credit not reflecting in 'Preview email'
* Fix: Infinite loop causing max execution time errors
* Fix: YITH Cart Messages disappeared when clicking on Available Coupons
* Fix: Product selection popup not opening on Classic Checkout for coupons with multiple choices.
* Fix: Prevented cart page from scrolling to top when changing shipping methods after applying a coupon via accordion UI
* Update: [Admin] Enhanced UI/UX for new user restrictions
* Update: [Admin] Enhanced UI/UX for Bulk Generate Coupon settings
* Update: Translation

2025.06.06 - version 9.39.0
* New: Coupon restrictions - "Coupon(s) can be used with" and "Coupon(s) can't be used with"
* New: Arabic, Dutch & Italian translations (AI-generated)
* Fix: Sending emails for coupons that are about to expire, even for the coupons with zero amount
* Fix: Fatal error for issue related to Aelia Multi-Currency plugin compatibility
* Update: Translations

2025.05.26 - version 9.38.2
* Fix: Uncaught ReferenceError wc_sc_send_coupon_form_block_frontend is not defined on WooCommerce Checkout Block
* Update: Translations

2025.05.23 - version 9.38.1
* Fix: Checkout page stuck on loading spinner, blocking order completion
* Fix: Collapsible section "Available Coupons" was always visible even when no coupons were available
* Update: Translations

2025.05.22 - version 9.38.0
* Fix: Cart total not updating when Store Credit is removed on WooCommerce Blocks-based Cart & Checkout pages
* Update: Improved performance by removing debug_backtrace() to reduce memory usage
* Update: Updated 'Available Coupons' section to show coupons only when needed
* Update: Translations

2025.05.15 - version 9.37.0
* New: Tested up to WordPress 6.8.1
* New: Tested up to WooCommerce 9.8.5
* New: Russian & Japanese translations (AI-generated)
* Fix: PHP Warning: Trying to access array offset on value of type null in 'save_coupon_receiver_detail_in_order' when using Block-based Checkout
* Fix: Store Credit amount not reducing when applied to order [Admin]
* Fix: Coupon export with email address in the search filter does not work as expected
* Fix: Auto-apply coupon with "Usage limit per user" did not work as expected when the same guest user (identified by email) came back for a second purchase
* Fix: Removed leftover data from deleted auto-apply coupons that is not needed anymore
* Update: Translations

2025.05.05 - version 9.36.0
* New: Tested up to WooCommerce 9.8.3
* New: Spanish & Chinese translations (AI-generated)
* Fix: Store credit not detected by YITH POS resulting in 0 credit applied to cart
* Fix: Uncaught Error: Call to a member function get_code() on null during preview of expiry reminder email
* Fix: 'Smart Coupons restrictions' are not persisting the set restrictions like 'Product attributes'
* Fix: Auto-apply not working for asterisk (*) based email addresses in 'Allowed emails' and 'Excluded emails'
* Fix: PHP Warning: Trying to access array offset on value of type bool thrown when setting 'Combine emails' is not set
* Fix: Uncaught Error: Call to a member function get_items() on null thrown when coupons are generated via REST API with parameter 'sc_is_send_email = yes' [BRW - Booking Rental Plugin WooCommerce]
* Fix: Product quantity based restriction working as AND condition instead of OR condition
* Fix: Replace help tip with description for two checkbox settings
* Developer: Filter 'wc_sc_product_quantity_condition' to modify product quantity restriction condition (any or all)
* Update: Translations

2025.04.24 - version 9.35.0
* New: Tested up to WooCommerce 9.8.2
* Fix: Products from 'Actions (tab) > Add products to cart' are not getting added in CartFlows Checkout
* Fix: Auto Apply Coupon does not apply with 'Product quantity based restrictions' until applied Store Credit has balance
* Fix: Unable to checkout due to error 'No payment method provided' on WooCommerce Block based checkout, when applied store credit is fully covering the order amount
* Update: Refactored the 'Usage restrictions' tab by showing only those fields that are configured, to reduce user interface (UI) clutter & improve clarity
* Update: Improved performance for coupon options 'Product attributes' and 'Exclude attributes' by adding a search-based selection
* Update: Translations

2025.04.17 - version 9.34.0
* New: Tested up to WordPress 6.8
* New: Tested up to WooCommerce 9.8.1
* Fix: Unable to override 'Coupon Expiry Reminder' email template
* Fix: Duplicate Store Credit doubling in Integration with AvaTax and WooCommerce Subscriptions
* Fix: PHP Notice: Undefined index in custom taxonomy
* Fix: PHP Fatal error: Uncaught TypeError: Unsupported operand types: string * string
* Update: Translations

2025.04.10 - version 9.33.0
* New: Support for custom taxonomies under 'Usage restrictions'
* Fix: Aelia multi-currency values no longer storing in the postmeta table
* Fix: Auto apply coupon is not working with payment method restrictions
* Fix: Resolved an issue where coupons imported via CSV and scheduled for future publishing, did not appear on the front end after being published
* Fix: Optimized ajax request on cart and checkout page to reduce server strain and improve performance
* Fix: 'Cheapest Product Discount' promotion did not apply correctly to the lowest-priced product when a new item was added to the cart
* Fix: Incorrect refund amount displayed on the admin order edit page when decimal separator is other than dot (.)
* Update: Store Credit validation has been improved to apply only to the relevant line item(s) in the cart, rather than all items, when Store Credit has a taxonomy restriction
* Update: Translations

2025.04.01 - version 9.32.0
* Fix: Database upgrade notice not showing after deleting the Smart Coupons custom table
* Fix: Ensured the recurring product discount applies only to the cheapest product when selected, instead of all products [WooCommerce Subscriptions]
* Fix: Duplicate coupon's and Store Credit coupons no longer appear during recalculation on the order edit page in WooCommerce Subscriptions
* Fix: Store Credit coupons are no longer applied on subscription orders, as Store Credit is not a recurring coupon [Admin]
* Fix: Store Credit amount changing unexpectedly when placing an order with an auto-generated gift card coupon [Admin]
* Fix: Store Credit amount being removed on subscription updates
* Fix: Remove store credit details from the Subscription Page
* Fix: Store credit will be doubled when the order status getting updated [ Admin ]
* Fix: When an order containing multiple products is placed and subsequently canceled from the backend, the store credit is partially refunded
* Fix: Store credit restrictions with product inclusions are applying incorrect discounts when creating orders
* Fix: Incorrect calculations are being applied to cart item line totals and taxes when the "Apply Before Tax" option is disabled
* Update: Translations

2025.03.24 - version 9.31.0
* New: Tested up to WooCommerce 9.7.1
* Fix: PHP warning when passing a single email address as string to the function 'generate_coupon'
* Fix: 'Maximum quantity' field of 'Product quantity restrictions' is not effective
* Fix: When 'Prices entered with tax' is 'inclusive of tax', 'Auto apply' coupons are not checking 'Minimum spend' field effectively
* Fix: Empty rows in the imported CSV file is creating coupons in draft
* Fix: Auto apply coupon is not removing on the classic cart and checkout page
* Update: In the plugin's setting, replaced help tips with detailed descriptions
* Update: Translations

2025.03.13 - version 9.30.1
* Fix: Percentage Discount coupons shows as fixed price
* Update: Translations

2025.03.12 - version 9.30.0
* Fix: Auto Apply coupons does not apply when the cart restrictions are triggered based on quantity restrictions
* Fix: Coupon design templates doesn't respect WooCommerce setting for currency position
* Update: Improved Auto Apply caching to ensure re-evaluation of eligible coupons when cart contents change
* Update: Translations

2025.03.04 - version 9.29.1
* Fix: JavaScript error (Identifier 'applyCouponAjaxRequest' has already been declared) that was interrupting available coupons functionality in Classic Checkout
* Fix: Coupon is not valid when an email is added on the checkout page
* Update: Translations

2025.02.28 - version 9.29.0
* New: Tested up to WooCommerce 9.7.0
* New: Modified Smart Coupons email templates to support WooCommerce's latest email preview feature
* Fix: Save the order discount total, including the Store Credit amount when 'Apply before tax' setting is enabled
* Fix: Auto-apply coupon not checking for an existing user for the email address entered during guest checkout
* Update: Translations

2025.02.25 - version 9.28.0
* New: Tested up to WooCommerce 9.6.2
* New: Allow product selection when multiple products are set in the "Actions" tab > "Add products to cart" [WooCommerce Classic/Shortcode-based Cart & Checkout page]
* Fix: Removed unnecessary padding by hiding empty coupon containers when no applicable coupons exist [checkout]
* Update: Translations

2025.02.13 - version 9.27.0
* New: Tested up to WordPress 6.7.2
* Fix: The coupon is not displaying when created using Smart Coupons' in-built function to create coupons
* Fix: Coupons restricted with Product categories for variable product not showing up
* Update: Translations

2025.02.11 - version 9.26.0
* New: Tested up to WooCommerce 9.6.1
* Fix: Force shipping method selection when a coupon with free shipping and restrictions is applied manually
* Fix: Prevent duplicate queries caused by the Smart Coupons Blocks integration
* Update: Database upgrade notice for better clarity for the fix related to order analytics data
* Update: Translations

2025.01.24 - version 9.25.0
* New: Tested up to WooCommerce 9.6.0
* Fix: Scheduling coupons 'Later' now uses date and time format set on the website [Shortcode-based Checkout page]
* Fix: Unable to change shipping methods after applying a coupon restricted to a specific shipping method
* Fix: Unable to load shepherd.min.mjs module [Guided Tours]
* Update: UI improvements in the 'Actions' tab related to the note message
* Update: Translations

2025.01.21 - version 9.24.0
* New: Tested up to WooCommerce 9.5.2
* Fix: Uncaught DivisionByZeroError: Division by zero
* Fix: Available coupons not shown properly due to incomplete database upgrade
* Fix: Available coupons loading twice on cart and checkout pages with smoother animation
* Fix: Store Credit incorrectly calculating order total with multiple tax rates [Admin]
* Fix: Validation of non-auto-apply coupon considering them as auto-apply coupon
* Developer: Filter 'wc_sc_enable_coupon_slide_animation' to enable/disable animation of available coupons
* Update: Translations

2025.01.14 - version 9.23.0
* Fix: HTML codes are visible in store-wide notice 'Black Friday Special Offer'
* Fix: Customers are not able to see their coupons in some cases
* Fix: A few WooCommerce's core methods related to discount total, not giving correct results when these methods are getting called from some external code
* Fix: PHP Fatal error - Unsupported operand types string * int
* Fix: An incorrect file path is being passed causing failure in getting version
* Fix: Gift card amounts not getting converted correctly in some cases with the Aelia Currency Switcher [Admin]
* Update: Translations

2025.01.08 - version 9.22.0
* Fix: Corrected net value stats of old orders where store credit made totals zero during the database upgrade
* Fix: Creation of dynamic property WC_Order::$sc_total_credit_used is deprecated
* Fix: Handle coupon validation during order created from YITH POS
* Fix: Correctly store gift purchase amounts in the selected currency with Aelia Currency Switcher
* Fix: Ensure coupon deductions align with the selected currency amount in Aelia Currency Switcher
* Fix: Manual discounts now persist when items are removed from admin-created orders [Admin]
* Update: Translations

2024.12.30 - version 9.21.0
* New: Tested up to WooCommerce 9.5.1
* New: Added Polylang compatibility for coupon restrictions with a filter 'enable_wc_sc_polylang_compatibility' to toggle integration (disabled by default)
* Fix: Auto generate coupons does not respect the settings for WooCommerce Subscriptions [WC Blocks]
* Fix: Auto-apply coupon not removing for WooCommerce Subscriptions product
* Fix: Auto-apply not working for coupons with attribute restrictions by ensuring accurate filtering of coupons based on product attribute IDs
* Update: Moved options & settings related to WooCommerce Subscriptions to its dedicated class
* Update: Ensure all the data are being written to CSV file at the earliest during coupon data generation
* Update: Translations

2024.12.27 - version 9.20.1
* Fix: Undefined array key 'Version'
* Update: PHP compatibility for html_entity_decode, fgetcsv, utf8_encode, nullable type method argument
* Update: Translations

2024.12.18 - version 9.20.0
* New: Tested up to WordPress 6.7.1
* New: Tested up to WooCommerce 9.4.3
* New: Added holiday season based themes for storewide notice for coupons
* New: Added more palettes of colors for coupons
* New: Added button to generate more combinations from the palettes of colors for coupons
* Fix: Consider variation parent product as well for validating auto-apply coupons
* Fix: Subject of the emails generated by the plugin are showing HTML codes
* Fix: Added some formatting to the emails generated from the plugin
* Fix: Coupons created via the REST API were not adding in custom table, affecting the display of coupons
* Fix: Coupon applying based on the item, not considering the cheapest product in the cart
* Fix: PHP Notice: Function _load_textdomain_just_in_time was called incorrectly for features of class 'WC_SC_Privacy' [WordPress 6.7+]
* Fix: PHP Notice: Undefined variable: is_callable_coupon_update_meta, generated while saving a coupon
* Fix: Wrong/incorrect text domain for a few strings
* Update: Converted single-page setting page of the plugin to multiple section-based pages
* Update: Translations

2024.11.27 - version 9.19.1
* Fix: PHP Notice: Function _load_textdomain_just_in_time was called incorrectly

2024.11.26 - version 9.19.0
* Fix: Corrected order total calculation for orders placed via [WC Blocks]
* Fix: Email coupon expiry dates showing incorrectly due to time zone mismatch
* Fix: PHP Fatal error: Uncaught TypeError: str_contains: must be of type string
* Fix: Auto-Apply When adding variable products to the cart, coupon with auto apply enabled is not getting applied
* Update: Translation

2024.11.20 - version 9.18.0
* New: Tested up to WordPress 6.7
* New: Tested up to WooCommerce 9.4.1
* Fix: Resolved issue with coupon discount and store credit calculation in the frontend, email, and admin
* Fix: Auto apply coupon notice is not showing in the product page
* Fix: In custom table, column 'date_expires' is getting set to null when 'wc_sc_expiry_time' is null
* Fix: Under coupon's setting 'Actions' tab, field 'each with quantity' appearing twice
* Fix: Discount row added by the plugin 'Points and Rewards by WP Swings' is not visible
* Fix: No discount applied by store credit when the entire code of the store credit is numeric
* Fix: Available coupons are not updating in the cart as expected
* Fix: Sometimes notice for database upgrade not going away when the cache is enabled
* Developer: Filter 'wc_sc_show_email_addresses' to manage display for 'Sender' and 'Receiver' email address
* Developer: Filter 'wc_sc_batch_size_for_coupons_for_reminder' for modifying the batch size for sending coupon expiry reminder email
* Update: Improved performance for custom table operations: creation, updates, auto-applying coupons, and displaying valid coupons
* Update: Performance improvement by moving codes meant for running once to appropriate function
* Update: Translation

2024.11.11 - version 9.17.0
* New: Reminder email for customers to notify them about expiring coupons
* Update: Translations

2024.11.08 - version 9.16.0
* Fix: In some cases, Store credit getting deducted twice when applied to an order
* Fix: Unnecessarily showing 'Sorry, coupon code has already been applied and cannot be used in conjunction with other coupons' when an individual use coupon is applied
* Fix: Discount types not updating correctly while importing coupons
* Fix: Product set under 'Actions' tab, is not added to the cart, when auto apply is enabled
* Fix: Call to undefined function wp_register_script_module [Tours]
* Update: Translations

2024.10.30 - version 9.15.0
* New: Setting to allow selection of product when multiple products are set in the 'Actions' tab > 'Add products to cart' [WC Blocks]
* New: Introducing 'Use case tours'. Added a few use case tours.
* Fix: Smart Coupons is ignoring discounts applied by WPC Product Bundles
* Fix: PHP Fatal error: Uncaught TypeError: Unsupported operand types: int + string
* Update: Improved UX for Smart Coupons fields & its description for better understanding
* Update: Translations

2024.10.21 - version 9.14.0
* Fix: Added support for payment method changes in block-based checkout, ensuring backend updates and coupon validation based on the selected method
* Fix: Reduced multiple notices about using individual use coupons with others
* Update: Translations

2024.10.15 - version 9.13.0
* Fix: Removing a product from an order in the admin panel results in an incorrect coupon value calculation
* Fix: Ensure appropriate data type being used when transposing data to Smart Coupons custom table
* Fix: Replaced the dollar sign with 'jQuery' to prevent conflicts
* Update: Translations

2024.10.07 - version 9.12.0
* New: Tested up to WooCommerce 9.3.3
* Fix: Added validation to prevent new coupon application if 'individual use' coupons are already applied in the classic cart
* Fix: The coupon with the 'For New User Only' and 'Auto Apply' features was being incorrectly applied to all users, instead of being limited to new customers only
* Fix: Coupon applied by 1-click was not reflecting immediately
* Fix: The wpdb::prepare function was called incorrectly during the reset of the Smart Coupons custom table
* Developer: Added method 'generate_coupon_url' and filter hook 'wc_sc_generate_coupon_url' for handling & managing coupon URLs
* Update: A few file versions and added context in some translated strings
* Update: Translations

2024.09.30 - version 9.11.0
* New: Tested up to WooCommerce 9.3.2
* Fix: NULL value is getting set in Smart Coupons custom table where only boolean value is allowed
* Fix: In some cases, discounts are applying twice [WC Blocks]
* Update: Removed cart & checkout block info from WooCommerce > Status as it's already available under WooCommerce > Status > WooCommerce Pages
* Update: URL cleanup by removing un-required parameter
* Update: Translations

2024.09.16 - version 9.10.0
* New: Tested up to WordPress 6.6.2
* Fix: Coupon Taxonomy restrictions to work with the AND condition
* Fix: Email not sent when bulk generating email-restricted coupons with 0 discount and defined coupon actions
* Fix: Refund store credit compatibility with Aelia Currency Switcher for WooCommerce
* Fix: Error WC_Coupon::set_error_message(): Argument 1 must be of type string
* Update: Translations

2024.09.10 - version 9.9.0
* Fix: Store Credit with product category restrictions does not respect the 'Apply before tax' setting
* Fix: The applied store credit amount is also included under 'Coupons' on the order admin page
* Fix: Undefined array key 'no_of_coupons_to_generate'
* Fix: Not using WooCommerce's setting for decimal during the price calculations for a 100 percent discount
* Fix: Coupons are not re-validating, and cart totals are not updating when the billing email changes during checkout
* Update: Translations

2024.09.04 - version 9.8.3
* Fix: Query to fetch coupons failing when the customer's account email & billing email is same

2024.09.02 - version 9.8.2
* Fix: Displaying coupons that are not meant to be shown
* Update: Translations

2024.08.30 - version 9.8.1
* Fix: WordPress database error Table 'wc_smart_coupons' doesn't exist
* Fix: Notice 'WooCommerce Smart Coupons database update completed. Thank you for updating to the latest version!' is not going away even after successful database upgrade
* Fix: A few plugin files are not within the allowed path(s)
* Update: Translations

2024.08.28 - version 9.8.0
* New: Added tools for specific plugin tasks
* Fix: Issue with importing coupons via CSV
* Update: Improved performance
* Update: Translations

2024.07.30 - version 9.7.0
* New: Tested up to WordPress 6.6.1
* Fix: Coupons passed in URL is not getting applied in block-based cart & checkout
* Fix: Applied store credit showing the amount as zero when store credit discount is inclusive of tax
* Update: Translations

2024.07.17 - version 9.6.0
* Fix: Restricting nonce verification so that it doesn't affect AJAX request of other plugin
* Fix: Normalized file path for imported file for all platforms
* Fix: Ensured consistent tax amount across cart, checkout, order admin, and email [WooCommerce Block]
* Update: Translations

2024.07.06 - version 9.5.0
* New: Tested up to WordPress 6.5.5
* New: Tested up to WooCommerce 9.0.2
* Fix: Shortcode attribute 'categories' for shortcode 'wc_sc_available_coupons' is not effective
* Fix: 1-click coupon not applying on the cart & the checkout page [WooCommerce Blocks]
* Fix: Orders created with the application of store credit are getting marked as fully refunded even if the order is refunded partially [Admin]
* Fix: WooCommerce coupon discounts displaying the wrong amount in the order received page
* Fix: Strengthen security [Thanks to: WooCommerce team]
* Fix: Notice: 'WC_Cart::is_coupon_emails_allowed' was called incorrectly. This method has been deprecated and will be removed soon
* Fix: Uncaught TypeError: Argument 1 passed must be of the type string or null, array given in class-wc-sc-product-columns.php
* Fix: Uncaught TypeError: count(): Argument 1 ($value) must be of type Countable|array, string given in class-wc-sc-coupons-by-taxonomy.php
* Developer: Filter 'wc_sc_filter_coupons_for_email' to allow customers to modify coupon data before sending email
* Update: Removed 'action-scheduler' as it's available in WooCommerce
* Update: Replaced use of 'esc_attr' with 'esc_html'
* Update: Changes related to identifying WooCommerce's latest version
* Update: Functions that check for WooCommerce version
* Update: Merge different WooCommerce compatibility files into one
* Update: Translations

2024.06.19 - version 9.4.0
* New: Coupon option to 'Apply discount on' cheapest or costliest items of the cart
* Fix: Uncaught Error: Call to a member function is_type() on bool in class-wc-sc-product-columns.php
* Fix: Available coupons not visible in cart [WooCommerce Block]
* Update: Translations

2024.06.14 - version 9.3.0
* New: Tested up to WordPress 6.5.4
* New: Tested up to WooCommerce 8.9.3
* Fix: Coupons were not being automatically applied when changing the shipping method
* Fix: Auto-apply is not working with the minimum and maximum spend amount of the coupon
* Update: Translations

2024.06.07 - version 9.2.0
* Fix: PHP Fatal error - Unsupported operand types string * int
* Update: Revamp 'Store Credit' calculation while creating manual orders from admin panel
* Update: Translations

2024.05.31 - version 9.1.0
* Fix: When Smart Coupons is active and WooCommerce is deactivated, it results in a fatal error
* Fix: The same block of JavaScript code is being added multiple times on the Checkout page
* Update: Added translation for the entire DateTimePicker of the plugin
* Update: Added information about whether the cart and the checkout page are block-enabled or not, under WooCommerce > Status
* Update: Improved the format of the data shown by the plugin and the format of the data coming in the report from the page WooCommerce > Status
* Update: Removed an extra space from the link 'Smart Coupons Settings' on the 'Bulk generate' page
* Update: Translations

2024.05.22 - version 9.0.1
* Fix: PHP Fatal error: Uncaught Error: Class 'Automattic\WooCommerce\StoreApi\StoreApi' not found with lower version of WooCommerce
* Update: Translations

2024.05.20 - version 9.0.0
* New: Tested up to WordPress 6.5.3
* New: Tested up to WooCommerce 8.3.1, 8.4.0, 8.5.2, 8.6.1, 8.7.0, 8.8.3
* New: Compatible with the Cart & the Checkout page powered by WooCommerce Blocks
* New: Block 'Available Coupons' for displaying valid coupons on the Cart & the Checkout page
* New: Block 'Send Coupon Form' to allow the purchaser to handle how the coupon should be delivered
* Fix: Incorrectly passed email address instead of WC_Email object in email templates
* Developer: Brought back hook 'generate_smart_coupon_action' for allowing to add more functionality during the coupon auto-generation from the Smart Coupons
* Update: Incorrectly showing the message about manual generation of coupons in the order edit admin page even when it's not going to generate any coupon
* Update: File smart-coupon.min.css
* Update: changelog.txt
* Update: Translations

2024.05.03 - version 8.23.0
* Fix: Auto-generating coupons is not copying the 'Product quantity based restrictions' from parent coupon
* Update: Handle sequence of application of store credit when 'Apply before tax' is enabled
* Update: Restrict the enqueue of Smart Coupons' JavaScript code to only required places
* Update: Convert the jQuery code to native JavaScript code
* Update: Translations

2024.04.25 - version 8.22.0
* Update: Improvements to the coupon discount calculations at order level when 'Apply before tax' is disabled
* Update: Translations

2024.04.23 - version 8.21.0
* Fix: Fixed issue with free item not being added with specific action.
* Fix: Fixed issue with coupon not being removed when coupon item is removed.
* Fix: Resolved a bug causing incorrect order calculation.
* Fix: Fixed an issue where store credit deduction amounts were not calculated accurately.
* Fix: Ensured that the amount is correctly reversed when a store credit coupon is removed.
* Fix: Fatal error: Uncaught Error: array_map(): Argument #2 ($auto_apply_coupon_ids) must be of type array, string given
* Update: Use setter method 'set_error_message' to set 'error_message' in coupon object
* Update: Translations

2024.04.16 - version 8.20.1
* Fix: Fatal Error: Cannot access protected property WC_Coupon::$error_message
* Fix: Uncaught TypeError: array_slice(): Argument #1 ($emails) must be of type array, string given
* Update: Replace 'woo.com' with 'woocommerce.com'
* Update: Translations

2024.04.05 - version 8.20.0
* Fix: Actions tab product not updating on creating new order
* Update: Coupon Usage Restriction added max quantity field for 'Product quantity based restrictions'
* Update: Translations

2024.03.21 - version 8.19.0
* Fix: Store Credit coupon getting included in Subscription renewal orders irrespective of whether it's used or not
* Update: Compatibility with WooCommerce 8.7 for changes in coupon line item storage in the order
* Update: Coupon field 'Original amount' not updating when the coupon is generated via Legacy API
* Update: Save 'Usage restrictions > Taxonomy' detail in the coupons that are generated from 'Marketing > Coupons > Bulk Generate' tab from admin side
* Update: POT, PO & MO file

2024.03.13 - version 8.18.0
* Fix: Amount of the store credits that are auto-generated, are not saving on default currency - WooPayments Multicurrency
* Fix: Coupon URL's notice not appearing when cart is empty
* Update: Consider 'fee' in discount calculation by store credit when 'Apply before tax' is disabled
* Update: POT, PO & MO file

2024.02.16 - version 8.17.0
* Fix: Applying coupons via URL shedding extra query params
* Update: Added some delay to execute the JS event 'update_checkout'
* Update: Code improvements
* Update: POT, PO & MO file

2024.02.08 - version 8.16.0
* New: Setting to enable-disable auto apply feature of coupon
* Fix: Store Credits are not generating for orders that are paid with Google Pay & Apple Pay payment gateway
* Update: POT, PO & MO file

2024.02.05 - version 8.15.0
* Fix: Coupon Usage Restriction field 'Product quantity based restrictions' is not getting updated when used in 'Bulk generate' & 'Import-Export'
* Fix: Uncaught Error: Call to a member function get_cart() on null
* Update: POT, PO & MO file

2024.01.19 - version 8.14.0
* New: Translation files (PO & MO files) for German language
* Fix: Product that is selling store credit of any amount, is not adding to cart when the add to cart is happening via AJAX
* Update: POT, PO & MO file

2024.01.12 - version 8.13.0
* Fix: Uncaught Error: Cannot use object of type stdClass as array
* Fix: When store credit is fully covering the order total making the amount to be paid as 0 (zero), on trying to place such order, it's always giving the error 'No payment method provided' [WC Blocks]
* Tweak: Handle display of coupon field 'Auto apply?' using JavaScript ES6 instead of jQuery
* Developer: New filter 'wc_sc_force_validate_allowed_emails' to control the behavior of validation of allowed emails
* Update: Add appropriate message when coupon is removed after email validation
* Update: 'Action Scheduler' updated to version 3.7.0
* Update: POT, PO & MO file

2024.01.02 - version 8.12.0
* Fix: Auto-apply coupon not working correctly with Payment method restriction
* Add: New filter hook 'wc_sc_allow_custom_refund_amount' to allow custom refund amount from order edit admin page
* Tweak: Improvement to early return from method 'smart_coupon_get_discount'
* Update: POT, PO & MO file

2023.12.08 - version 8.11.0
* New: WordPress 6.4.2 compatible
* Fix: Coupon applied via Coupon Shareable link was not reflecting in Side Cart [WooCommerce Side Cart Premium by XootiX]
* Fix: Exponential notation in custom price was not getting processed correctly for store credit of any amount, causing generation of store credit of higher value
* Fix: Undefined variable: $calculated_product_price
* Update: POT, PO & MO file

2023.12.02 - version 8.10.0
* Update: Use native WooCommerce hook 'woocommerce_loop_add_to_cart_link' to replace 'Add to cart' button in 'loop' (archive pages like 'shop' page)
* Update: Replace 'woocommerce.com' with 'woo.com'
* Update: POT, PO & MO file

2023.11.22 - version 8.9.0
* New: WordPress 6.4.1 compatible
* New: WooCommerce 8.2.2 compatible
* Fix: Auto apply does not work with WooCommerce Blocks
* Fix: 'Internal server error' during renewal that uses store credit [WooCommerce Subscriptions]
* Fix: Applied Store Credit amount shows in multiples in Cart & Checkout
* Fix: Call to undefined method WC_Subscriptions_Plugin::get_library_version
* Update: Add help text in empty 'Generated coupons' metabox on the Order edit admin page
* Update: POT file

2023.11.06 - version 8.8.0
* New: Feature to 'Regenerate' and/or 'Resend' coupons from order edit admin page
* Update: POT file

2023.10.27 - version 8.7.0
* New: WordPress 6.3.2 compatible
* New: WooCommerce 8.2.1 compatible
* Fix: PHP Warning: foreach() argument must be of type array|object, string given for $customer_emails
* Fix: Parent Coupons are not updating the Allowed emails
* Fix: When scheduling coupons via import, a blank email is sent with no coupons
* Fix: Actions tab product does not respect the discount on declined payments
* Fix: Linked Coupons label is breaking in product admin dashboard
* Fix: Active for x payments field shows for all discount types in 'Bulk generate' tab
* Tweak: Optimized a few queries
* Update: Updated translation file for French language, as it was causing 'Fatal error: Uncaught Error: 3 arguments are required, 2 given'
* Update: Correct a few file paths for inclusion
* Update: POT file

2023.09.22 - version 8.6.0
* New: Tested up to WooCommerce 8.1.1
* Fix: PHP Warning:  mysqli_free_result(): Couldn't fetch mysqli_result
* Fix: Refund of store credit from order admin page is not working with all possible decimal point
* Tweak: Database query performance optimization
* Update: POT file

2023.09.15 - version 8.5.0
* New: Tested with PHP 8.0, 8.1 & 8.2
* New: Tested up to WooCommerce 8.1.0
* New: Tested up to WordPress 6.3.1
* Fix: PHP Fatal error: Uncaught TypeError: str_getcsv(): Argument #1 ($string) must be of type string, array given
* Fix: PHP Fatal error: Uncaught TypeError: call_user_func_array(): Argument #1 ($callback) must be a valid callback, class SA_WC_Compatibility_4_4 does not have a method 'save_shortcode_generated_coupon'
* Fix: PHP Fatal error: Uncaught TypeError: Unsupported operand types: string + string
* Fix: PHP Fatal error: Uncaught TypeError: Unsupported operand types: int + string
* Fix: PHP Warning: foreach() argument must be of type array|object, string given
* Fix: PHP Deprecated: auto_detect_line_endings is deprecated
* Fix: PHP Deprecated: ltrim(): Passing null to parameter #1 ($string) of type string is deprecated
* Fix: PHP Deprecated: strtotime(): Passing null to parameter #1 ($datetime) of type string is deprecated
* Update: POT file

2023.08.21 - version 8.4.0
* New: Tested up to WordPress 6.3.0
* New: Tested up to WooCommerce 8.0.2
* Fix: When a coupon that is having some products set under 'Coupon actions', is tried to be applied using 'Coupons shareable link', that coupon is being applied without validating the coupon This results in an additional coupon validation error notice
* Fix: Coupons are losing style when tried to print on Mozilla Firefox browser
* Update: POT file

2023.08.08 - version 8.3.0
* New: Tested up to WooCommerce 7.9.0
* Fix: Auto apply is not considering 'Allowed emails' and 'Excluded emails' field
* Fix: Scheduling coupons via CSV import publishing coupons immediately
* Fix: Coupons scheduled to be send later from the checkout page are getting published & sent immediately
* Fix: Browser console error 'wp is not defined' when trying to open calendar to schedule coupon
* Fix: PHP Notice: Deprecated: Creation of dynamic property WC_SC_Background_Coupon_Importer::$prefix is deprecated
* Tweak: Query only the required taxonomy for Coupon's Usage restrictions field 'Taxonomy'
* Update: Force date time picker to appear on top
* Update: Added data in the 'post_date' column in supported format in the sample.csv file
* Update: Action Scheduler to version 3.6.1
* Update: POT file

2023.07.07 - version 8.2.0
* New: Tested up to WooCommerce 7.8.2
* Fix: Texts that appear on timepicker added by the plugin, are not translatable
* Fix: Returning unescaped value
* Update: Minor improvements
* Update: POT file

2023.06.23 - version 8.1.0
* Fix: Refund amount blocked on the order edit page, even when store credit is not applied to that order
* Fix: When bulk generating coupons with multiple values for 'Exclude products', only the first value is getting saved
* Fix: When importing coupons with multiple values for 'Exclude products' via CSV file, only the first value is getting saved
* Fix: 'Fixed cart discount' coupon amount changed when a coupon is applied to an order and when the plugin [WooCommerce Multi-Currency](https://woocommerce.com/products/multi-currency/) OR the plugin [Price Based on Country for WooCommerce](https://wordpress.org/plugins/woocommerce-product-price-based-on-countries/) is active
* Update: POT file

2023.06.16 - version 8.0.0
* New: Tested up to WooCommerce 7.8.0
* New: Store credit applying to an order using WooCommerce coupon discount API when 'Apply before tax' is disabled
* New: Automatically adjust the refund amount that will be refunded first to the store credit applied to the order, on the order edit page
* New: Method 'is_sc_gte' for comparing with the current version of the plugin
* Fix: Option 'sc_display_global_coupons' resetting on any coupon update
* Fix: Admin notification messages related to coupon bulk generation, import, export
* Tweak: Replaced the use of __() with _x() at a few instances
* Tweak: Try to exit early from a few method
* Developer: New filter 'wc_sc_max_url_coupons_limit' for setting maximum number of coupons that can be applied via URL at one time
* Update: For store credit, add columns in the order edit page under order item's list based on the number of tax rates
* Update: Removed option 'Auto-fill refund amount' that appears while refunding an order & the order has store credit, on the order edit page
* Update: Add currency to the amount that is refunded to store credits on order edit page
* Update: Display refund amount field for store credit only if some amount is left to be refunded, on the order edit page
* Update: Set max limit on the refund amount field for store credit
* Update: Use the label set for store credit in the refund row, on the order edit page
* Update: Set human-readable label for order item meta added by the Smart Coupons plugin (e.g. '_wc_sc_product_source')
* Update: Set a few order item meta added by Smart Coupons plugin as hidden
* Update: Translate field 'discount_type' when coupon is imported via CSV for setting correct discount type for the coupon
* Update: Coupon actions field 'with discount of' will follow the WooCommerce setting for 'Number of decimals'
* Update: Added support for fetching serialized data for options
* Update: Minor improvements
* Update: POT file

2023.06.02 - version 7.12.0
* New: Tested up to WooCommerce 7.7.2
* New: Show linked coupons to a product on the products listing page (dashboard)
* Fix: Store credit amount is ignored when paying via 'WooCommerce PayPal Payments' plugin
* Update: Removed directory 'woo-includes'
* Update: Use Aelia Currency Switcher's conversion only when Aelia Currency Switcher plugin is active
* Update: Escape values to be shown under the coupon dashboard column 'View order'
* Update: POT file

2023.05.24 - version 7.11.0
* New: Tested up to WordPress 6.2.2
* Fix: 'Coupons' field under product is breaking due to conflict with Yoast Pro for WooCommerce
* Fix: On the Checkout page, if opted to send coupons to self, it is still validating email fields that are mistakenly left in the provided email field
* Update: POT file

2023.05.12 - version 7.10.0
* New: Tested up to WooCommerce 7.7.0
* New: During coupon import process, option to choose to update existing coupons
* Fix: Unnecessarily displaying coupon field 'Disable email restriction?' in auto-generated coupons
* Fix: Warning: Invalid argument supplied for foreach '$taxonomy_restrictions'
* Fix: Fatal error: Uncaught Error: Call to a member function getOffsetTimestamp on null when importing CSV file containing existing coupons
* Fix: Coupon method 'set_used_by' expects parameter to be an array
* Tweak: Query performance improvement when loading store-wide coupons
* Tweak: Improvements in method 'sc_get_option'
* Update: Maintain & show count of coupons skipped during bulk generate or import process
* Update: POT file

2023.05.05 - version 7.9.0
* Fix: Data under the coupon field 'Actions > Display message' is broken when saved
* Fix: Replaced use of function 'WC_Product::get_parent' with 'WC_Product::get_parent_id'
* Update: POT file

2023.04.28 - version 7.8.0
* New: Tested up to WooCommerce 7.6.1
* New: Under coupon meta field 'Usage restriction > Locations', load States defined by WooCommerce for selection
* Fix: Auto-apply functionality not working correctly with coupon meta field 'Usage restriction > Locations'
* Fix: Auto-apply functionality is forcing WooCommerce Points & Rewards (requires 1.7.29+) plugin to display messages on the 'My Account' page
* Fix: Auto-generated coupons only saving the 1st value under 'Usage restriction > Products' & 'Usage restriction > Excluded products', if multiple values are passed
* Fix: PHP Warning: foreach() argument must be of type array|object, string given
* Developer: New action hook 'wc_sc_before_auto_apply_coupons' to perform actions before auto-apply functionality
* Tweak: Unnecessarily executing 2 lines of code in a loop
* Update: Run auto-apply feature on AJAX-based requests as well
* Update: Added custom message for coupon meta field 'Usage restriction > Locations' if the entered location is not found
* Update: Passed discount object as 3rd argument for filter hook 'woocommerce_coupon_is_valid'
* Update: Minor improvements
* Update: POT file

2023.04.21 - version 7.7.0
* Fix: Emails for coupons are not getting sent when the setting 'Combine emails' is enabled
* Fix: Do not call 'get_post_meta' for coupon meta 'discount_type' if the post id is empty
* Update: Minor improvements
* Update: POT file

2023.04.15 - version 7.6.0
* New: Tested up to WooCommerce 7.6.0
* Fix: Product attribute restriction not validating correctly in case of variable products
* Fix: Sometimes a few meta fields of coupons are missing (coupon code, original amount) when it is auto-generated
* Fix: Incorrectly displaying coupons of another user whose email address is similar to the email address of the current user
* Fix: Uncaught wc_data_exception: invalid discount amount when the Smart Coupon balance is going below 0
* Update: Change log type from 'error' to 'notice'
* Update: POT file

2023.04.07 - version 7.5.0
* New: Tested up to WordPress 6.2
* Fix: 'get_page_by_title' is deprecated since WordPress 6.2
* Fix: Auto apply feature not working for users with multiple roles
* Fix: 'Payment methods' restrictions giving error when store credit is more than order total
* Fix: Fatal error: Uncaught Error: Call to undefined method WC_Coupon::set_status() with WooCommerce 6.1.2 or lower
* Tweak: Remove unnecessary use of 'debug_print_backtrace'
* Tweak: Use object for initializing, if available, instead of id
* Developer: Hook 'wc_sc_invalid_coupons_list_title' and 'wc_sc_invalid_coupons_list_description' for changing title & description for section 'Invalid/Used coupons' on My Account page
* Update: Linked auto-apply feature with appropriate hooks instead of 'wp_loaded'
* Update: POT file

2023.03.24 - version 7.4.0
* New: Compatible with WooCommerce HPOS (High Performance Order Storage)
* New: Tested up to WooCommerce 7.1.1, 7.2.3, 7.3.0, 7.4.1, 7.5.1
* Fix: Unable to empty/update a few coupon's meta field like 'Products'
* Fix: Importing only 1st value from multiple values from a few fields like 'product_ids' and 'exclude_product_ids'
* Update: Replace use of 'add_post_meta' with CRUD function 'set_used_by'
* Update: Replace string 'ARRAY_A' with constant ARRAY_A
* Update: Removed global declaration of $wpdb form where it is not used
* Update: Format coupon usage URL using add_query_arg instead of hard-coded URL
* Update: POT file

2023.03.13 - version 7.3.0
* New: Columns 'Allowed emails' and 'Excluded emails' in Coupon's admin dashboard
* New: Shortcode attribute 'categories' for shortcode 'wc_sc_available_coupons' for filtering coupon list by coupon categories
* New: Wrapper function for using 'WC_Discounts->is_coupon_valid' for validating coupons
* Fix: 'Preview email' button not showing under Send store credit tab when the store is not having a single coupon
* Fix: Uncaught TypeError: Unsupported operand types: string + string
* Fix: 2 coupon URLs are not working when clicked back to back
* Developer: Moved code for showing coupon category column in appropriate class file
* Developer: Pass coupon object as an additional arguments to methods used for rendering the respective columns
* Developer: Filter 'wc_sc_available_coupon_ids' for filtering coupon ids to search for displaying available coupons
* Developer: Filter 'shortcode_atts_wc_sc_available_coupons' for modifying shortcode attributes
* Developer: Filter 'wc_sc_shortcode_no_coupon_found_text' for adding text when no coupon found to be displayed via shortcode 'wc_sc_available_coupons'
* Tweak: Default value in wrapper function for 'get_option'
* Update: POT file

2023.02.24 - version 7.2.1
* Fix: Error: Something went wrong. For details, check 'woocommerce-smart-coupons...' log under WooCommerce > Status > Logs
* Update: POT file

2023.02.20 - version 7.2.0
* New: Use of CRUD functions throughout plugin
* Fix: Missing 3rd argument causing issues when using filter 'woocommerce_payment_complete_order_status'
* Fix: Incorrectly updating store credit balance when order is having virtual-downloadable product & more than one coupon is applied to that order
* Update: POT file

2023.01.18 - version 7.1.0
* New: Credits & coupons were not getting generated & emailed when paid with [Klarna Checkout for WooCommerce](https://wordpress.org/plugins/klarna-checkout-for-woocommerce/)
* Fix: Auto apply does not happen when 'Disable email restriction?' is enabled
* Fix: Failing to add order item via AJAX that is triggered by another plugin
* Update: POT file

2022.12.28 - version 7.0.0
* Fix: When refunding an order from the refund form provided on the admin side, and in that order store credit is used, double amount is getting restored in that store credit
* Fix: When refunding an order from the refund form provided on the admin side, and in that order store credit is used, refund related meta not getting saved
* Fix: Shortcode 'smart_coupons' generating new coupons each time the page is refreshed
* Fix: 'Exclude user roles' not checking user's role when checking out as guest user
* Fix: Gift products set under 'Actions' (tab) is not getting added to cart after clicking coupon from cart, checkout page
* Fix: 'Original amount' of the store credit is not getting set when the coupon is generated either from 'Bulk generate' (tab), 'Import' (tab) or 'Send store credit' (tab)
* Fix: Uncaught exception 'Error' with message 'Call to a member function get() on null' [YITH WooCommerce Wishlist]
* Tweak: Correction in indentation as per WordPress Standards
* Tweak: Minor spelling correction
* Developer: New filter 'wc_sc_is_email_required_for_sending_coupon' to decide whether email address is required for sending coupon or not
* Update: Translation & language related changes in the template 'acknowledgement-email.php'
* Update: POT file

2022.12.16 - version 6.9.0
* Fix: Fatal error: Uncaught Error: Call to undefined function mb_detect_encoding
* Fix: When refunding an order that is paid by store credit, receiving PHP Fatal error: There has been a critical error on this website. Uncaught TypeError: gmdate(): Argument #2 ($timestamp) must be of type ?int, string given
* Update: FAQs included in the plugin
* Update: POT file

2022.12.08 - version 6.8.0
* New: Tested up to WordPress 6.1.1
* Fix: Incorrectly allowing more quantities than the set quantities for products set under Actions (tab)
* Fix: When creating order at backend applying-removing-reapplying store credit makes calculations differ
* Fix: Wrong amount generated on store credit coupon when order created from the admin side
* Fix: Setting 'Sell gift cards at less price?' not considered when order with the coupon product is created from admin
* Fix: Store Credit discount sets to zero when used with WooCommerce Deposits plugin
* Fix: Confirm if a loop can be executed on the variable $coupon_actions before execution
* Update: POT file

2022.11.11 - version 6.7.0
* New: Usage restriction field 'Excluded emails'
* Fix: 'For new user only?' setting is not working in a specific case
* Developer: Hook 'wc_sc_start_coupon_options_email_restriction'
* Developer: Filter & option 'wc_sc_coupon_product_need_processing' to decide whether to automatically mark the order as 'completed' for coupon products
* Update: Automatically mark the order as 'completed' if that order contains only those products that will generate/issue coupons
* Update: Added icon for 'Manage coupon categories' button on Coupons dashboard admin page
* Update: Corrected text domain at one place
* Update: POT file

2022.11.04 - version 6.6.0
* New: WooCommerce 7.0.1 compatible
* New: WordPress 6.1 compatible
* New: A new way for applying 1-click coupon via AJAX
* Fix: Coupon not applying in order created via REST API
* Developer: Filter 'wc_sc_apply_coupon_via_ajax' for choosing method of applying coupon via AJAX or via URL (default: via AJAX)
* Update: POT file

2022.10.21 - version 6.5.0
* New: WooCommerce 7.0.0 compatible
* New: WordPress 6.0.3 compatible
* Update: Removed magic method __wakeup
* Update: POT file

2022.10.13 - version 6.4.0
* Fix: When bulk generating, importing or sending store credit with an empty coupon expiry date, it is setting the date as 1970-01-01 which is invalidating all those coupons
* Fix: Not checking for an empty value for delivery date if 'Deliver coupon' is set to 'Later'
* Update: Filter 'wc_sc_deliver_coupon' to set default option for 'Deliver coupon' to 'Later' on the checkout page when the customer is opting to send the coupon to someone else
* Update: Set autoload for 'sc_wc_db_update_status' option as 'no'
* Update: Spelling correction from 'Certficate' to 'Certificate'
* Update: POT file

2022.10.06 - version 6.3.0
* Update: Correctly handle and validate expiry date & time
* Update: POT file

2022.09.26 - version 6.2.0
* New: Display store credit original amount in the coupon's admin dashboard
* New: Setting & hook 'wc_sc_show_myaccount_menu_icon' to show or hide icon for coupons menu/tab on My account page
* Fix: The coupon in which 'Disable email restriction?' is enabled under Usage restrictions, those coupons don't show up under the drop-down for 'Enable store notice for the coupon'
* Fix: Unable to identify Smart Coupons' endpoint under My account using function is_wc_endpoint_url
* Fix: Coupon URL feature not working correctly with URL param 'add-to-cart'
* Fix: Setting Free shipping is not working correctly with the discount type store credit
* Fix: Usage restrictions > Payment methods are not validating correctly when the coupon is used in creating/updating an order via REST API
* Fix: Auto-generating a percentage discount coupon is also converting the percentage amount of the coupon [Aelia Currency Switcher for WooCommerce]
* Fix: Incorrectly converting store credit original amount during auto-generation [Aelia Currency Switcher for WooCommerce]
* Fix: Coupon amount is not geting converted in store notice for coupon [Aelia Currency Switcher for WooCommerce]
* Fix: User experience when applying a coupon with Payment method restriction on the cart & the checkout page
* Fix: Uncaught TypeError: Cannot access offset of type string on string - $this->locations_lookup_in['address']
* Fix: Hard-coded table prefix in query, replaced with $wpdb->prefix
* Fix: Unnecessarily logging a lot of messages in the log file during refund process [Admin]
* Fix: Spelling mistake in 'You have scheduled to sent...' to 'You have scheduled to send...'
* Fix: A few minor spelling mistakes
* Update: POT file

2022.09.12 - version 6.1.1
* Fix: Applied store credit is displaying incorrect amount in order edit page [admin]
* Fix: Incorrect amount getting restored in store credit which is applied to an order & that order is refunded [admin]
* Fix: Store credit of fixed but variable amount generating store credit with an incorrect amount
* Fix: Incorrect currency conversion in auto-generated coupons or credits when the amount is defined in the coupon & pick product price is disabled
* Update: POT file

2022.09.02 - version 6.1.0
* New: Compatibility with Aelia Currency Switcher for WooCommerce
* Update: POT file

2022.08.19 - version 6.0.1
* Fix: Uncaught Error: Class 'WC_Subscriptions' not found [WooCommerce Payments]
* Fix: PHP Warning: call_user_func_array() expects parameter 1 to be a valid callback, class 'SA_WC_Compatibility_4_4' does not have a method 'get_coupon_options'
* Update: POT file

2022.08.10 - version 6.0.0
* Fix: Fatal error stalling subscription renewal in a few cases
* Update: Minor change related to WooCommerce Subscriptions 4.0.0
* Update: Translation for the French language
* Update: Spell checks & a few cleanup
* Update: POT file

2022.08.03 - version 5.9.0
* New: Tested up to WooCommerce 6.7.0
* Fix: Incorrect discount calculation when using settings 'Max discount' & 'Limit Usage to X items' together in a percentage discount coupon
* Fix: Product quantity based restrictions fields causing coupons to not apply on empty cart
* Fix: Uncaught TypeError: Unsupported operand types: int * string
* Update: POT file

2022.07.20 - version 5.8.0
* New: Tested up to WordPress 6.0.1
* Update: Generate new coupon code if post_title is empty during CSV import
* Update: POT file

2022.07.13 - version 5.7.0
* New: Tested up to WooCommerce 6.6.1
* Fix: JavaScript error: Unable to access properties of undefined [Klarna]
* Fix: Emails when having spaces next to comma won't sent out emails from 'Send store credit' tab
* Fix: Translation in the coupon design
* Update: New address link for feature requests
* Update: Added 'Store credit used' detail in the response of WooCommerce REST API (v3) request for order
* Update: POT file

2022.06.16 - version 5.6.0
* Update: Stop or ignore scanning expired coupons to improve performance
* Update: POT file

2022.06.02 - version 5.5.0
* New: Tested up to WordPress 6.0
* New: Add Smart Coupons related details in WooCommerce > Status report
* Fix: Broken UI on the order page where store credit is used but tax is not enabled
* Fix: Store credit usage information is not shown if those store credits are trashed
* Update: Added minified css file for smart-coupon.css
* Update: The coupons that can be expanded to see sender & receiver details, remove arrows that are visible around those coupons
* Update: POT file

2022.05.16 - version 5.4.0
* New: Tested up to WooCommerce 6.5.1
* New: Set id of the template coupon as post_parent of the auto-generated coupon
* New: A button just below the coupon code to copy it [admin]
* Fix: Re-validating quantity of products added from the Actions tab of coupons which is not correct
* Fix: Applying store credit multiple times when the order contains only virtual & downloadable products
* Fix: When number of coupons to generate & number of email address supplied is different, then incorrectly setting Allowed emails & also sending emails during Bulk generate & Import of coupons
* Update: Do not copy post_parent while duplicating a coupon
* Update: Added minified version of a CSS file 'smart-coupons-admin' [admin]
* Update: Corrected a few letter case, default data based on data type
* Update: POT file

2022.04.29 - version 5.3.0
* New: Tested up to WooCommerce 6.4.1
* New: Filter coupon's list by coupon category under 'Marketing > Coupons'
* Fix: Store Credit is applying discount before tax, like a coupon, even when the setting 'Apply before tax' is disabled
* Fix: Preview in admin not showing coupon amount & expiry date under 'Marketing > Coupons > Send Store Credit' tab
* Fix: Unable to partially refund an order that is paid with store credit
* Update: POT file

2022.04.15 - version 5.2.0
* New: Tested up to WooCommerce 6.4.0 & WordPress 5.9.3
* Fix: Use 'fwrite' instead of 'file_put_contents' [WP VIP team]
* Fix: Subscription renewals not issuing full priced store credit if other coupon is applied to subscription during purchase [WooCommerce Subscriptions]
* Update: POT file

2022.04.01 - version 5.1.0
* Fix: Email showing incorrect remaining balance if store credit is applied to a virtual-downloadable order
* Fix: PayPal Payments plugin sometimes rejecting applied store credit amount
* Developer: Filter Hook 'wc_sc_check_parent_attributes' for deciding whether to check attributes mentioned under 'Product data > Attributes (tab)' or not
* Update: Store credit not applying discount when applied via REST API during order creation
* Update: Product's attributes mentioned under 'Product data > Attributes (tab)' are not considered by coupon's Product attributes restrictions for validation of the coupon
* Update: POT file

2022.03.21 - version 5.0.0
* New: Tested up to WooCommerce 6.3.1 & WordPress 5.9.2
* New: Feature 'Usage restriction based on product quantity'
* Update: POT file

2022.03.04 - version 4.38.0
* Developer: New filter hook 'wc_sc_pending_order_statuses'
* Developer: Removed filter hook 'wc_sc_order_statuses_to_restore_smart_coupon_amount', should use 'wc_sc_pending_order_statuses' instead
* Update: Links to documentation, screenshots & reviews
* Update: Data type for $no_of_coupons_to_generate
* Update: POT file

2022.02.28 - version 4.37.0
* New: Tested up to WooCommerce 6.2.1 & WordPress 5.9.1
* Fix: Coupon not applying to cart via URL coupon if the URL contains 'add-to-cart' and the setting 'Redirect to the cart ...' is enabled [Thanks to: Bernd VanSkiver]
* Fix: Using the email template created for multiple coupons even if it's about to send just one coupon
* Developer: Hook 'wc_sc_order_statuses_to_restore_smart_coupon_amount' for modifying list of order statuses needed to restore smart coupon amount
* Update: POT file

2022.02.04 - version 4.36.0
* New: Tested up to WordPress 5.9.0
* Update: Action Scheduler to version 3.4.0
* Update: POT file

2022.01.24 - version 4.35.0
* New: Tested up to WooCommerce 6.1.1
* New: Column 'sc_coupon_category' in sample.csv file
* Fix: Shipping validation failing on live shipping method
* Update: Improvement in coupon code generation logic
* Update: POT file

2022.01.17 - version 4.34.0
* New: Tested up to WooCommerce 6.1.0 & WordPress 5.8.3
* New: Support for coupon categories under bulk generate, import & export
* Update: Coupon not applying to cart via URL coupon if the URL contains 'add-to-cart'
* Update: Prevent generating coupon codes with profanity
* Update: Replaced use of 'is_ajax' with 'wp_doing_ajax'
* Update: POT file

2021.11.22 - version 4.33.1
* Fix: Fatal Error: Uncaught Error: Call to undefined function post_exists()
* Update: POT file

2021.11.18 - version 4.33.0
* New: WooCommerce 5.9.0 compatible
* New: Tested up to WordPress 5.8.2
* Fix: Displaying error 'Uncaught Exception: Invalid coupon' under the order admin page > Generated coupons meta box, when a coupon that is auto-generated got deleted
* Fix: Support for wildcard email under Allowed emails during 'Bulk generate' & 'Import coupons'
* Update: POT file

2021.10.26 - version 4.32.0
* Fix: Incorrect discount calculation when cart is having Product Bundles & max discount is set in the coupon
* Update: POT file

2021.10.22 - version 4.31.0
* Fix: Auto apply coupons once removed automatically, not reapplying again even if it's valid
* Update: POT file

2021.10.15 - version 4.30.0
* New: Tested up to WooCommerce 5.8.0
* Fix: Ignoring user role restrictions when the product is getting added to cart from frontend via AJAX
* Fix: Discount coupon getting visible on all variations of a product even though the coupon is associated with a single variation
* Fix: The amount field in 'Purchase credit of any amount' is not showing when set up using Elementor or Astra theme
* Fix: Uncaught ArgumentCountError: Too few arguments to function WC_Smart_Coupons::is_smart_coupon_valid(), 2 passed and exactly 3 expected [WooCommerce 3.1.2 or lower]
* Update: Minor improvements
* Update: POT file

2021.10.08 - version 4.29.1
* Fix: Warning: call_user_func() expects parameter 1 to be a valid callback, class 'SA_WC_Compatibility_4_4' does not have a method 'get_smart_coupons_version'
* Update: POT file

2021.10.08 - version 4.29.0
* Fix: PHP Notice: Trying to get property 'post_type' of non-object
* Update: Coupon meta 'Exclude user roles', 'Taxonomy', 'Payment methods', and 'Shipping methods' are not getting copied in auto-generated coupon
* Update: POT file

2021.10.01 - version 4.28.0
* New: Tested up to WooCommerce 5.7.1 & WordPress 5.8.1
* Update: Use transient for auto-cleanup of options that starts with 'sc_applied_coupon_profile_'
* Update: Spellchecks
* Update: POT file

2021.09.06 - version 4.27.0
* New: Settings in acknowledgement email ('Subject' and 'Heading') to handle texts related to scheduled email
* New: Option 'wc_sc_auto_apply_coupon_removable' and hook 'wc_sc_is_auto_apply_coupon_removable' to allow removal of auto-apply coupons
* Fix: Under 'Import Coupons' 'Email coupon to recipients?' not appearing if there is no email added in the first row of the CSV file
* Fix: Incorrect calculation in store credit when used in manually created orders
* Fix: Coupon type in the acknowledgement email is always of the discount type 'smart_coupon' irrespective of the coupon sent
* Developer: New hook 'wc_sc_redirect_url_after_smart_coupons_process' to allow 3rd party plugin to modify the redirect URL after the plugin has processed the URL coupons
* Update: Tweaking in auto-apply feature
* Update: Changes in texts in email templates for acknowledgement email
* Update: Allow removal of auto apply coupons
* Update: Minor improvements
* Update: POT file

2021.08.23 - version 4.26.0
* New: Tested up to WooCommerce 5.6.0 & WordPress 5.8.0
* Update: Improvements in auto-apply feature
* Update: Set a session cookie to persist the coupon in case the cart is empty [Thanks to: Devon Godfrey]
* Update: Minor improvements
* Update: Changes in HTML for displaying coupon shareable link on the admin side
* Update: POT file

2021.07.06 - version 4.25.1
* Fix: Notice: Undefined variable: user_role during guest checkout
* Fix: Notice: Undefined variable: email during guest checkout
* Update: POT file

2021.07.05 - version 4.25.0
* Fix: Cancelled PayPal payment returns cart total to 0 on gift certificate purchases
* Update: Auto-apply functionality to consider usage restrictions as well
* Update: POT file

2021.06.25 - version 4.24.0
* Update: Coupon shareable link not working with page slug or page id
* Update: Ignore usage restriction related to user roles when the coupon is getting applied from admin side
* Update: POT file

2021.06.16 - version 4.23.0
* New: Tested up to WooCommerce 5.4.1
* Fix: 1-click coupon apply not working with CheckoutWC
* Fix: WordPress database error Table doesn't exist when referring to users table in a multisite environment [Thanks to: Bradley Cross]
* Update: During manual creation of order from admin side, allow application of coupon that is restricted for user roles
* Update: POT file

2021.06.03 - version 4.22.0
* Fix: CRITICAL Uncaught Exception: This coupon is valid for the first order only
* Fix: Incorrect calculation when multiple store credit is applied
* Fix: 'Coupon shareable link' not working, added param 'sc-page' in the shareable link
* Update: Hook 'wc_sc_is_filter_content_coupon_message' to decide whether to filter the content of the coupon message or not, before displaying on the website
* Update: Default arguments for method WC_SC_Coupon_Message::wc_add_coupons_message_in_email [PHP8]
* Update: POT file

2021.05.19 - version 4.21.0
* New: Tested up to WooCommerce 5.3.0 & WordPress 5.7.2
* Fix: PHP Warning: The magic method WC_Smart_Coupons::__wakeup() must have public visibility [PHP8]
* Fix: Named parameters in call_user_func_array [PHP8] [Thanks to: Noah]
* Update: Documentation link for coupon search limitations for the setting 'Enable store notice for the coupon'
* Update: POT file

2021.05.10 - version 4.20.1
* Fix: 'Show on cart, checkout and my account?' functionality not working since last update
* Update: POT file

2021.05.05 - version 4.20.0
* Fix: Performance issues when trying to display coupons on cart/checkout pages in some cases
* Fix: Amount field doesn't appear sometimes while purchasing credit of any amount [Thanks to: Matt]
* Update: POT file

2021.04.26 - version 4.19.0
* New: Tested up to WooCommerce 5.2.2 & WordPress 5.7.1
* Developer: New hook 'wc_sc_json_search_storewide_coupons' to allow 3rd party plugin to modify search result of storewide coupon
* Update: Set autoload of all Smart Coupons related options as 'no'
* Update: French translation
* Update: POT file

2021.03.26 - version 4.18.0
* Developer: New hook 'wc_sc_credit_remaining' to allow 3rd party plugin to modify remaining credit before saving it [Thanks to: Diego Zanella | Aelia.co]
* Fix: Remove 'sticky' admin notice about import completion [Thanks to: Les Xue | WordPress VIP]
* Tweak: Code cleanup
* Update: Move displaying coupon message on 'updated_checkout' event instead of 'update_checkout' [Thanks to: Diego Zanella | Aelia.co]
* Update: Change location of files created by the plugin to a secure location
* Update: Specific error message for 'new user' coupons
* Update: POT file

2021.03.08 - version 4.17.5
* Fix: Expiry date is not being displayed in the coupon that is sent in the email
* Fix: Prevent the modification of the minimum & maximum amount during the purchase of credit of any amount from the browser
* Update: Additional arguments for filter 'wc_sc_is_auto_generate'
* Update: POT file

2021.02.24 - version 4.17.0
* New: Tested up to WooCommerce 5.0.0 & WordPress 5.6.2
* Fix: Expiry time is not being considered during coupon validation
* Fix: Generated store credit amount is not considering currency [Multi Currency for WooCommerce By VillaTheme]
* Fix: Sometimes the latest imported coupons are not getting activated if the code already exists
* Fix: Incorrect validation of the fields 'Product attributes' & 'Exclude attributes' under Coupon data > Usage restriction tab
* Fix: Validation based on product taxonomies not working if the taxonomy is related to the parent product
* Update: Use the date format of the website to display expiry date in the coupons
* Update: Added hook to control the number of attributes for field 'Product attributes' & 'Exclude attributes' under Coupon data > Usage restriction tab
* Update: Correction in a few PHPDocBlocks
* Update: POT file

2021.02.05 - version 4.16.5
* Fix: Product attributes restrictions are not getting copied in auto-generated coupons
* Fix: Coupons are not getting sent on renewals only in case of variable subscription
* Fix: Auto-apply coupons not working for 'Recurring Product % Discount' coupon if the sign up fee is 0 (zero)
* Update: POT file

2021.02.01 - version 4.16.0
* New: Tested up to WooCommerce 4.9.2
* Update: Improvements related to sanitizing & escaping data
* Update: POT file

2021.01.15 - version 4.15.0
* New: Tested up to WooCommerce 4.9.0
* Fix: Error 'Invalid payment method' when fully paid via store credit [WPML]
* Fix: When the 'Max discount' is set, sometimes the discount calculated is not accurate
* Update: POT file

2021.01.05 - version 4.14.0
* Fix: 'Exclude attributes' restriction overriding 'Exclude categories' restriction
* Fix: 'Max discount' is not getting calculated properly in case of WooCommerce setting for a decimal value other than 2
* Fix: Setting 'Disable email restriction' not working in case of coupons scheduled to be sent at a later date
* Fix: Purchased coupons that are scheduled to be sent later via email, are not getting emailed in some cases
* Fix: Removed unnecessary 'console.log'
* Fix: HTML & CSS of add & remove button of 'Taxonomy' restrictions for responsiveness
* Update: Display details of scheduled coupons in order under 'Generated coupons' meta box
* Update: POT file

2020.12.10 - version 4.13.0
* New: Tested up to WooCommerce 4.7.1, 4.8.0 & WordPress 5.6.0
* New: Coupon usage restrictions for various product taxonomies
* Update: Support for modifying the input field provided for those products which allows purchasing store credit of any amount
* Update: Better handling of validation of the input field for those products which allows purchasing store credit of any amount
* Update: Pass the expiry date through a common formatting function on the Smart Coupons admin setting page
* Update: CSS for coupon location field
* Update: POT file

2020.11.09 - version 4.12.2
* Fix: Uncaught ReferenceError: sc_coupon_message_ajax is not defined
* Fix: Uncaught ReferenceError: sc_available_coupons_ajax is not defined
* Update: POT file

2020.11.07 - version 4.12.1
* New: Tested up to WooCommerce 4.6.2
* Fix: Email not sending for purchased coupons which are scheduled to be sent 'LATER'
* Fix: Not checking order statuses while validating new user coupon in the case of guest users
* Fix: Sometimes showing fatal error if a coupon which is about to be displayed is deleted
* Fix: Uncaught Error: Using $this when not in object context from 2 templates: email.php & combined-email.php
* Fix: JavaScript error: Trying to declare the variable a second time
* Update: Hook 'wc_sc_max_coupon_to_show_on_myaccount' & setting 'wc_sc_setting_max_coupon_to_show_on_myaccount'
* Update: Limit on the number of coupons to be loaded in the coupons tab on the my account page
* Update: Improvements in coupon tabs on the my account page such that segments will get loaded only if it has some data
* Update: Use coupon setting 'Exclude sale items' during generation of coupon description
* Update: Set the position of Print button to right on my account page
* Update: Minor change in logic of displaying coupon to ensure correct number of coupons to display as per setting
* Update: POT file

2020.11.02 - version 4.12.0
* New: Tested up to WooCommerce 4.6.1 & WordPress 5.5.3
* New: Usage restriction to exclude user roles
* New: Feature to select quantity of the products which will be added to cart on applying a coupon (under Coupon data > Actions tab)
* Fix: Incorrectly showing description of one coupon as description of other coupons
* Fix: Remove unnecessary CSS from styles of coupons which are going in the email
* Update: sample.csv file
* Update: POT file

2020.10.26 - version 4.11.0
* New: Allow linking of coupon to variations as well
* Developer: Hook 'wc_sc_is_filter_content_coupon_message'
* Update: Highlight Smart Coupons' field under product
* Update: Coupon design templates for handling empty coupon amount
* Update: API namespace
* Update: POT file

2020.10.19 - version 4.10.0
* New: Tested up to WooCommerce 4.6.0
* New: API support for generating coupons
* Fix: Incorrectly overriding 'custom-design' for coupon on saving the settings
* Fix: Incorrectly adding 'is_email' attribute when adding shortcode using WP editor button
* Fix: Reduce multiple AJAX request on the cart & the checkout page to one (happens only in some cases) (Thanks to: BuildWooFunnels)
* Fix: Links added in the message, which will be sent along with the coupon, those links are broken in the received email
* Update: Display store notice for coupon based on the coupon's status
* Update: Provide support for selecting order statuses to consider during the validation of new user coupons
* Developer: Hook 'wc_sc_should_coupon_auto_generate'
* Update: POT file

2020.10.09 - version 4.9.5
* New: Set a coupon to display as storewide offer coupon. It will be displayed everywhere on the website.
* Fix: Initialization of Action Scheduler package
* Update: Action Scheduler package to version 3.1.6
* Update: Delayed execution of function 'handle_coupon_process_on_3rd_party_order_statuses' to support necessary changes to take place
* Update: POT file

2020.09.28 - version 4.9.1
* Fix: Selected coupon design for email is not getting sent in the order received email
* Fix: Width of checkbox in 'Bulk generate form'
* Fix: Incorrectly selecting the colors setting for a coupon if the background & foreground color is already set
* Fix: Coupons in the email are not center-aligned
* Fix: Sometimes colors selected for coupons are not applying to coupons in the email
* Fix: Empty description in some coupons on the frontend
* Update: POT file

2020.09.23 - version 4.9.0
* New: Tested up to WooCommerce 4.5.2 & WordPress 5.5.1
* New: New improved coupon designs with some predefined color schemes
* New: Setting 'Include tax in the amount of the generated store credit'
* Fix: Unnecessarily showing 'Coupon does not exist' notice when trying to auto-apply a coupon which is in draft status
* Fix: Orders are not including generated coupon details when the setting 'Email auto generated coupons to recipients' is disabled
* Fix: Smart Coupons' shortcode button not visible in classic editor
* Update: Prevent querying the database if the store owner sets 0 coupons to show
* Update: Remove usage of deprecated jQuery event 'ready' [WordPress 5.5]
* Update: Additional information on 'Import CSV' page
* Update: Expiry date format in the coupon displayed on the website
* Update: Notice for minimum WooCommerce requirement
* Update: Add additional params on using Smart Coupons' shortcode button
* Tweak: Performance improvement in auto-apply coupon functionlity
* Developer: Overridable template support for coupon designs
* Developer: Additional arguments for hook 'wc_sc_before_shortcode_smart_coupons_html_start'
* Developer: Additional arguments for hook 'wc_sc_max_coupon_to_show'
* Developer: Additional arguments for hook 'wc_sc_max_auto_apply_coupons_limit'
* Developer: Hook 'wc_sc_is_send_coupon_email'
* Update: POT file

2020.09.08 - version 4.8.1
* Fix: Discount not applied on taxes when Apply before tax is disabled [WooCommerce AvaTax]
* Update: Remove usage of deprecated jQuery event 'ready' & function 'load' [WordPress 5.5]
* Update: POT file

2020.08.24 - version 4.8.0
* New: Group coupons by category
* New: Tested up to WooCommerce 4.4.1 & WordPress 5.5
* Fix: 'Click to Copy' updating coupon
* Fix: Max discount not working
* Update: Link color in footer
* Update: Code improvements for admin CSS
* Developer: Hook 'wc_sc_before_shortcode_smart_coupons_html_start'
* Developer: Hook 'wc_sc_coupon_code_allowed_characters'
* Developer: Hook 'wc_sc_is_coupon_restriction_available'
* Update: POT file

2020.08.05 - version 4.7.8
* New: Tested up to WooCommerce 4.3.1
* New: Template for purchasing credit of any amount (on single product page)
* New: Template for acknowledgement email that is sent to the purchaser of the coupon
* Fix: Bulk generate or import process not working in multisite sometimes
* Fix: Store credit is unable to apply discount when the price on the store is exclusive of tax [WooCommerce AvaTax]
* Update: An option to ignore notice 'Coupon was used in another transaction, and coupon usage limit is reached'
* Update: POT file

2020.07.10 - version 4.7.7
* New: Tested up to WooCommerce 4.3.0
* Fix: Database errors related to duplicate option entry 'sc_display_custom_credit_'
* Update: Feature to stop a running bulk generate/import coupon process
* Update: Feature to auto-stop a running process when the bulk generate/import process gets stuck
* Update: 2 additional attributes 'is_email' & 'is_clickable' for shortcode 'smart_coupons'
* Update: POT file
* Dev: Additional arguments for function get_coupon_styles
* Dev: Filter 'wc_sc_shortcode_always_generate_coupon'

2020.06.10 - version 4.7.6
* New: Tested up to WooCommerce 4.2.0
* New: Hook 'wc_sc_is_generated_store_credit_includes_tax' to decide whether generated store credit should include tax or not
* Update: Action Scheduler to latest version
* Update: POT file

2020.05.16 - version 4.7.5
* Fix: Continuously displaying error message about those auto-apply coupons which are deleted
* Update: POT file

2020.05.06 - version 4.7.4
* New: Tested up to WooCommerce 4.1.0
* Fix: Broken 'Coupon receiver detail' form
* Update: POT file

2020.04.22 - version 4.7.3
* Fix: Hitting button 'Enter' not adding product (created to sell store credit of any amount) to the cart
* Fix: Enabling the setting 'Combine Emails' doesn't have any effect. Coupons are not getting combined in email for the same user
* Update: Enqueue Smart Coupons CSS only if needed
* Update: POT file

2020.04.03 - version 4.7.2
* Fix: Notification for Bulk Generate > Export to CSV is not showing
* Fix: Admin Footer text not showing on Smart Coupons pages
* Update: Welcome page
* Update: POT file

2020.03.13 - version 4.7.1
* New: Tested up to WooCommerce 4.0
* Fix: PHP Warning: Invalid argument supplied for foreach
* Update: Setting to enable/disable feature to print coupons
* Update: POT file

2020.02.28 - version 4.7.0
* New: Allow printing of coupons
* Fix: Missing parameter in hook 'woocommerce_email_styles'
* Update: POT file

2020.02.21 - version 4.6.5
* New: Merge 'Send Store Credit' tab with 'Bulk Generate' tab
* New: Preview email while bulk generating coupons
* Update: Coupon display text for WooCommerce Subscriptions coupon types
* Update: POT file

2020.02.07 - version 4.6.0
* New: Feature to enable 'auto-apply' for a coupon
* New: Tested up to WooCommerce 3.9.1
* Fix: Uncaught TypeError: Cannot read property 'fragments' of undefined during checkout
* Fix: 'Send store credit' failing to send email when 'Combined Emails' is enabled
* Fix: Store credit getting deducted twice when applied on backend
* Fix: Validate coupon before attempting to apply from cookie (URL coupon)
* Fix: Product for purchasing credit getting added to cart with zero price
* Fix: Showing error 'Coupon was used in another transaction, and coupon usage limit is reached'
* Update: Responsive template for purchasing credit
* Update: Use sentence case for coupon fields in admin
* Update: Minor changes
* Update: POT file

2020.01.31 - version 4.5.6
* Fix: Issuing more than the purchased credit amount when setting 'Prices entered inclusive of tax' is enabled

2020.01.30 - version 4.5.5
* New: Setting to make store credit amount inclusive of tax when prices are inclusive of tax and 'Apply before tax' is enabled
* New: Link to view orders in which coupon has been used on coupon list page
* Fix: Emails not sending for store credits generated from 'Send Store Credit' tab when combining of email is enabled
* Update: Missing argument for hook 'woocommerce_coupon_options'
* Update: Compatibility files for WooCommerce
* Update: POT file

2020.01.10 - version 4.5.4
* Fix: Modifying cron schedule interval only when required
* Fix: Coupon preview under coupon style not visible [WP 5.3+]
* Fix: Changing endpoint setting only appears when Subscription plugin is active
* Update: POT file

2020.01.02 - version 4.5.3
* Update: Allow addition of products from coupon action on coupon application even when the cart is empty
* Update: POT file

2019.12.19 - version 4.5.2
* Fix: Discount not applied on taxes from AvaTax with Apply before tax setting disabled
* Fix: 'Select options' button not visible for any amount gift certificate product on shop page after adding the gift certificate product into the cart
* Fix: Adding sender email to 'woocommerce_email_header' and 'woocommerce_email_footer' actions while sending an acknowledgment email to sender[WC Standard]
* Fix: Duplicate call to WC_SC_Background_Coupon_Importer::is_process_running in some cases
* Developer: Filter 'wc_sc_linked_coupon_text' to change the text shown for linked coupons on linked product page
* Developer: Filter 'wc_sc_force_show_invalid_coupon' to allow showing of coupons which are invalid due to cart requirements like minimum order total or products
* Developer: Action 'wc_sc_no_available_coupons' to show custom message when no coupons are available for logged-in user
* Tweak: Removing dependency on Action Scheduler library in checking of background process status​
* Update: POT file

2019.11.28 - version 4.5.1
* New: WooCommerce 3.8.1 compatible
* Fix: Variable gift certificate product price not displaying in product description when variation is not discounted and 'Sell store credit at less price' is enabled

2019.11.22 - version 4.5.0
* New: Restrict Coupons by Product Attributes
* New: Setting to change endpoint for Coupons. The endpoint will appear in the URL when the customer is on My Account > Coupons page
* Fix: Emails not getting sent in some cases
* Fix: Email template override not working
* Fix: JavaScript error: Undefined 'woocommerce_admin_meta_boxes_coupon'
* Fix: Incorrect email preview layout under WooCommerce > Coupons > Send Store Credit tab
* Fix: Replacing usage of 'wc_selected' function with 'selected' function for better backward compatibility
* Update: Documentation links
* Update: POT file

2019.11.04 - version 4.4.1
* New: Move coupon emails in the WooCommerce email system for better handling
* New: Plain text emails for coupons
* Fix: Coupon actions not working in case of fixed amount gift voucher products
* Fix: Unable to empty coupon expiry time
* Developer: Filter 'wc_sc_calculate_totals_stop_at' to handle discount calculation for store credit
* Update: POT file

2019.10.19 - version 4.4.0
* New: Option to add custom style for coupons using CSS
* New: Apply multiple coupons from URL
* New: Setting to allow the buyer to send coupons to someone else (By default: Enabled)
* New: Save original store credit value in the coupon meta when it is auto-generated
* New: Copy coupon code action on coupons dashboard
* New: Get coupon shareable link on coupons dashaboard and edit coupon page
* Update: Support for performing Smart Coupons actions on order statuses which are added by 3rd party plugins
* Update: Docs, Support & Review links on plugins page
* Update: Admin Footer text for Smart Coupons pages
* Tweak: Export button on coupons dashboard
* Update: POT file

2019.10.08 - version 4.3.0
* New: Setting to allow combining of coupons emails when multiple emails are sent to the same recipient
* New: Restrict Coupons by User Roles
* Fix: Store Credit's amount not decreasing even after applying the discount on the renewal order [WooCommerce Subscriptions]
* Update: POT file

2019.10.05 - version 4.2.0
* New: Restrict Coupons by Payment Methods
* New: Restrict Coupons by Shipping Methods
* Fix: Bulk Coupon import not working in some cases
* Update: Make all the constructor of Singleton classes as private
* Update: POT file

2019.09.27 - version 4.1.3
* Fix: Not showing coupon receiver detail form under checkout section [WooCommerce One Page Checkout] IS#84
* Fix: Display of gift card amount in summary of the linked coupons when setting 'Sell store credit at less price' is enabled
* Fix: Duplicate coupon showing on cart, checkout & my account page
* Update: Updated code as per the latest version of WordPress Standard
* Update: Prevent unnecessary loading of some JavaScript code
* Update: Prevent unnecessary database call for options 'wc_sc_coupon_code_length', 'sc_store_credit_singular_text', 'sc_store_credit_plural_text', 'sa_cbl_additional_locations'
* Update: jQuery improvements related to deprecated functions, replaced '.live' with '.on'
* Update: Make the word 'Now' & 'Later' translatable
* Update: POT file

2019.09.16 - version 4.1.2
* Fix: Unable to create/auto-generate coupons that are having some actions but the amount field is either zero or empty
* Fix: Use Action Schedulers only when required to speed up bulk generate process when small number of coupons has to be processed
* Update: Show admin notice when upload directory is not writable to avoid empty coupon codes generation.
* Update: POT file

2019.09.03 - version 4.1.1
* New: Set a max discount amount for percentage discount type coupon
* New: Set expiry time for coupon [WC3.2+]
* Update: POT file

2019.08.23 - version 4.1.0
* New: Allow buyers to schedule delivery of coupons during purchase
* New: WooCommerce 3.7 Compatibility
* Fix: Import Coupon CSV not working [WC3.7]
* Fix: Smart Coupons' setting not saving [WC3.7]
* Fix: PHP Notice:  get_used_coupons is deprecated [WC3.7]
* Fix: Coupon bulk export/import performance
* Fix: Incorrect price showing in Receiver detail form when selling of credit at less price is enabled
* Update: A few changes in CSS
* Update: Responsiveness of "Email to customer" description under WooCommerce > Coupons > Bulk Generate tab
* Update: Alignment of amount field in template 'call-for-credit-form.php'
* Update: POT file

2019.08.13 - version 4.0.9
* New: Allow creating store credit/gift certificate with product's regular price/customer entered price instead of sale price/discounted price
* New: Show message for coupons applied via URL
* Fix: PHP 7+ warnings
* Fix: Coupon's details are not visible on product's page when the product is a variable product
* Fix: Sometimes showing any entry to purchase credit field as invalid amount
* Fix: Sometimes purchase credit form is getting included more then once, causing failure of the feature
* Update: Change text 'Percentage discount' to 'discount' everywhere as '%' sign is already shown with coupon amount
* Update: Smart Coupons setting labels
* Update: POT file

2019.06.24 - version 4.0.8
* Fix: Fatal Error: Could not find class 'ActionScheduler'
* Fix: Incorrect Subscription renewal order total when using a coupon having option 'Add products to cart' is used
* Fix: Store credit charged but discount is not applied to order when registering a user and placing the order both at the same time from the checkout page
* Fix: Store credit becomes 0 on checkout when WooCommerce Services plugin's 'Automated Taxes' setting is enabled
* Fix: Store credit not being reduced when customer places failed order and later order status is changed to on-hold/processing/completed
* Update: Welcome page CSS
* Update: POT file

2019.06.15 - version 4.0.7
* Tweak: Improved bulk generation, export & import of coupons using Action Scheduler Library
* Removed: Background Process Library
* Update: POT file

2019.06.03 - version 4.0.6
* Fix: PHP Warning:  date() expects parameter 2 to be long, string given
* Fix: Error message: Uncaught Error: [] operator not supported for strings [Shortcode]
* Fix: PHP Notice: Undefined index while auto-generation of coupon in some cases
* Update: Welcome page CSS

2019.05.22 - version 4.0.5
* New: Setting to allow auto-generation of coupons on specified order statuses only
* Fix: Warning: mysqli_free_result(): Couldn't fetch mysqli_result on activation of the plugin
* Update: Enable 'Apply before tax' setting for renewal orders as well [WooCommerce Subscriptions]
* Update: Ignore checking for tax enabled on store while processing 'Apply before tax' setting
* Tweak: Any changes made to Smart Coupons settings will now set the setting to not 'autoload'
* Update: POT file

2019.05.15 - version 4.0.4
* New: Tested up to WooCommerce 3.6.2
* Fix: Expiry date not setting in auto generated coupons
* Fix: Coupon Setting "Show on cart/checkout page" not displaying the coupon on cart/checkout page
* Fix: Adding product via Coupon Action with discount results in deducted price only showing after reload (Thanks to: Elias)
* Update: New option 'expiry_days' in shortcode [smart_coupons] for setting number of days after which the generated coupon will expire
* Update: POT file

2019.04.04 - version 4.0.3
* New: Option to allow coupon auto-generation on specific order statuses
* Fix: Fatal error (Call to a member function meta_exists() on boolean) during renewal of those subscriptions which are created manually (Thanks to: Ted Barnett)
* Update: POT file

2019.03.27 - version 4.0.2
* Fix: Uncaught Error: Call to a member function get_applied_coupons() on null
* Fix: Re-validate available coupons on updating order review on checkout page
* Fix: Incorrectly showing 'new user only' coupon to registered customer on cart page
* Update: Add available coupon's list in ajax fragments on checkout page
* Update: Reload available coupon's list on updating order review on checkout page
* Update: [Admin] Make the prefix 'email' case-insensitive to filter or search coupon by email
* Update: [HTML] Minor change in coupon list container
* Update: POT file

2019.03.19 - version 4.0.1
* New: Support for adding Coupon Description when Bulk Generating coupons
* New: Use selectWoo (For WooCommerce 3.2.0+)
* Fix: Missing row of applied store credit in renewal order (admin & email order table)
* Fix: PHP Warning: Illegal string offset 'address'
* Fix: Incorrect text domain at few places
* Fix: Welcome page CSS getting added on all admin pages
* Update: Show tip where to enter email addresses when Emailing to recipients from Bulk Generate tab
* Update: Scroll to top of the page to error notice on Bulk Generate tab
* Update: POT file

2019.02.25 - version 4.0.0
* New: Restrict Coupons By Location (Supports country, state, city, zip code)
* New: Action - Display Message on cart and checkout pages on successful application of the coupon
* New: Gutenberg block to display coupon for shortcode [smart_coupons]
* Fix: Setting for showing maximum number of coupons is not controlling the number of coupons to be shown (Thanks to: Scott Lewis)
* Fix: Incorrect expiry message for expired coupons
* Update: Show notice on admin panel when coupons are getting generated/imported in the background
* Update: Code improvements to get post_type
* Update: Welcome page
* Update: Quick links for Settings & FAQ's on Plugins page, Coupons page and tabs
* Update: Admin Footer text for Smart Coupons pages
* Update: Show 'Connect your store' notice on Smart Coupons pages
* Update: Tested up to WordPress 5.0.3
* Update: Compat files reordering
* Update: sample.csv file
* Update: POT file

2019.01.17 - version 3.9.1
* Fix: Applying the store credit amount twice after creating orders

2019.01.09 - version 3.9.0
* New: Introduction of background process for importing or bulk generation of coupons
* New: Search/Filter coupon's list by restricted email
* Fix: Call to undefined method WC_Coupon::get_meta() [WC 2.6.14 or lower]
* Fix: Import coupons from uploaded file on the server not working
* Fix: Support for coupon field 'Active for x payments' during auto/bulk coupon generation & import [WooCommerce Subscriptions 2.3.0+]
* Tweak: Disable autoload of few options
* Tweak: Loading of class for compatibility with WooCommerce Subscriptions
* Update: POT file

2018.12.20 - version 3.8.6
* Fix: Sometimes store credit is discounting double than it's actual amount on checkout page [WooCommerce AvaTax]
* Fix: WordPress database error Duplicate entry
* Fix: Store credit used data are not shown in order admin page if that store credit is deleted from the store (Thanks to: Jarrad Grigg)
* Fix: Coupon actions not working when a subscription product is in the cart [WooCommerce Subscriptions 2.3.4+]
* Tweak: Addition of product from coupon actions
* Tweak: Move checking of WooCommerce version from constructor to functions
* Tweak: Code Indentation
* Update: Initialization of Smart Coupons plugin
* Update: Number of arguments for hook 'woocommerce_coupon_is_valid'
* Update: Context for logging errors for Smart Coupons plugin
* Update: POT file

2018.11.28 - version 3.8.5
* New: Shortcode [wc_sc_available_coupons] to show available coupons on any page or post
* Fix: Sometimes while purchasing variable but fixed amount store credit, "Send coupons to..." section not visible on checkout page & also the coupons are not generated
* Fix: Theme's button style not applying on shop page for products which are created for purchasing credit
* Fix: Duplicate key error on inserting a value in table
* Fix: Coupons remain visible even after disabling the show on cart/checkout option
* Update: POT file

2018.11.14 - version 3.8.2
* Fix: Discounts applied from the store credit getting multiplied everytime when the page is refreshed, when "Apply before tax" setting of Smart Coupons is enabled
* Fix: Sometimes the store credit is not showing discount applied in cart, it's displaying the discount as 0.00
* Fix: Coupon with actions defined are not visible on cart, checkout & my account page when the coupon's amount is zero
* Developer: Filter to handle display of zero amount coupon
* Update: POT file

2018.11.06 - version 3.8.1
* New: WooCommerce 3.5.1 compatibility
* Fix: Searching coupon in shortcode pop-up is showing duplicate results
* Fix: New coupon designs not applying on preview of coupon in shortcode pop-up
* Fix: On removing coupon from checkout page, available coupon list not refreshing
* Fix: On clicking coupon, there's no indication of whether coupon is applying or not
* Fix: Broken HTML code in emails when the order is fully paid by store credit
* Fix: Logging error for WC lower than 3.0.0
* Fix: 'Coupon Receiver Detail' form on checkout page not showing correctly on few themes
* Update: Improved CSS for 'Coupon Receiver Detail' form on checkout page
* Update: sample.csv
* Update: POT File

2018.10.25 - version 3.8.0
* New: Customizable Coupon designs
* Fix: Restrict single-use coupon to billing email address of the guest user
* Fix: Correction in function arguments
* Fix: Show/hide of coupon not working correctly on the checkout page
* Fix: Responsiveness of Welcome page
* Update: POT File

2018.10.18 - version 3.7.2
* Fix: Store Credit not applying discount on manual renewal (WooCommerce Subscriptions)

2018.10.18 - version 3.7.1
* Fix: Inconsistent discount when store credit used in combination with other discount types
* Fix: Multiple store credits which are restricted to be used on a product, sometimes resulting in negative order total
* Fix: Clearing Smart Coupons cache not showing any message
* Update: Text domain
* Update: POT File

2018.10.08 - version 3.7.0
* New: Single usage coupon for new user only
* New: Manage number of characters in auto generated coupon code
* New: Rename "Store Credit/ Gift Certificate"
* Fix: Import notice not showing when importing coupons in bulk
* Fix: Incompatibility with PHP 7 which resulted in store credit not deducting on order placement
* Fix: Not showing "Free shipping coupons"
* Fix: Coupon codes having spaces not working when applied by 1-click, showing message "Coupon does not exists"
* Fix: Formatting (HTML encoding) to coupon code causing incorrect linking of the coupon to the product
* Fix: Fallback for text domain which was causing fatal error in some cases
* Fix: Duplicate deduction from store credit [TaxJar]
* Fix: Incorrect discount calculation by store credit [AvaTax]
* Fix: Store credit coupon is not being applied correctly when a Mix and Match product is in the cart [Mix and Match product] IS#80
* Tweak: UI improvements in settings for Smart Coupons labels
* Tweak: Tool to clear cache
* Tweak: Better handling of Smart Coupons cache
* Tweak: Clear cache on deactivation
* Update: sample.csv file
* Update: POT File

2018.09.04 - version 3.6.0
* New: WordPress Coding Standard
* Fix: Link for Smart Coupons settings, which appears in admin notice, pointing to wrong page
* Fix: Store credit of 0 is visible on cart/checkout page
* Fix: Setting 'Apply before tax' not working for orders created manually from backend
* Fix: Checkbox 'Send coupons on renewals' doesn't hide even if there are no coupons linked
* Fix: Checkbox 'Apply before tax' remains checked on checking the checkbox 'Use store credit applied in first subscription...'
* Fix: When multiple store credits were applied from backend then removal of any one store credit was restoring balance to all other store credits
* Update: POT File

2018.08.16 - version 3.5.0
* Feature: Additional action after applying coupon - Add products to cart
* New: Filter for modifying coupon code during generation
* New: Filter to change the title of the coupon being displayed in cart PR#76
* New: Filter to change coupon meta during export
* Fix: Add check to avoid sliding coupon list if there's no coupon PR#74
* Fix: Not showing store credit under "Invalid/Used Coupons" if it's used up
* Fix: Fatal error: call to a member function get on null [Follow-up Emails]
* Fix: Generated coupons are not sent in order completed email for guest user
* Fix: Some fields are empty during export
* Update: POT file

2018.07.18 - version 3.4.7
* Fix: '{site_title}' in email footer
* Fix: Duplicate deduction from store credit when 3rd party plugin is changing order status
* Fix: Duplicate deduction from store credit when changing order status via bulk update
* Update: Change text from 'Show on cart/checkout' to 'Show on cart, checkout and my account?'
* Update: Show notice when coupon is disabled on store
* Update: Change text 'Percentage discount' to 'discount' as '%' sign is already shown with coupon amount
* Update: POT file

2018.06.28 - version 3.4.6
* Fix: Store Credit deducting everytime when order status is updated from order action column from WooCommerce > Orders
* Fix: Setting 'Use store credit applied in first subscription order for subsequent renewals' is not getting disabled [WooCommerce Subscriptions]
* Fix: Sending coupon on renewals even if it is not enabled [WooCommerce Subscriptions]
* Fix: Amount is not deducting from store credit when a new store credit is getting used to pay for renewals [WooCommerce Subscriptions]
* Fix: Incorrectly increasing usage count of store credit which is applied to original order & it's being used to pay for renewals [WooCommerce Subscriptions]
* Update: Remove 'Coupon Receiver Detail' form when paying for renewal order [WooCommerce Subscriptions]
* Update: Hide unnecessary meta 'sc_called_credit' which appears with product name
* Update: Improved CSS for 'Coupon Receiver Detail' form on checkout page
* Update: POT File

2018.06.21 - version 3.4.5
* New: Error logging under WooCommerce > Status > Logs for logs generated by Smart Coupons plugin
* Fix: Coupon tab on My Account page is not showing any message if no coupon is available
* Fix: Store Credit is discounting only 1 quantity of an item when remaining order amount is paid via PayPal Standard [Thanks to: Oliver Zieschang]
* Fix: Coupons Linked to Products are Missing from Emails when Using PayPal (when there's delay in IPN notification from PayPal)
* Fix: Incorrect expiry date set in coupons during import when locale is defined
* Fix: Sometimes incorrectly showing error message on order-received page when store credit is getting used up completely in that order
* Fix: Minor fixes related to 'Call to member function on boolean'
* Update: POT File

2018.06.06 - version 3.4.4
* New: WooCommerce 3.4.2 compatibility
* Fix: PHP Notice:  Undefined variable: smart_coupons_block
* Fix: Error: Call to member function 'get_id' on boolean when updating order
* Fix: Store Credit deducting everytime when order status is updated from order admin page
* Update: Enabled Free Shipping, Usage Limit (Per Coupon, Per User) field for Store Credit
* Update: Apply remaining balance of store credit to renewal order even if it is less than renewal order total [WooCommerce Subscription]
* Update: POT File

2018.05.23 - version 3.4.3
* Update: Remove Order Personal data on WooCommerce hook
* Update: Query to handle lengthy data
* Update: Remove debug code
* Update: Text domain
* Update: POT file

2018.05.21 - version 3.4.2
* New: [GDPR] Privacy Policy Content
* New: [GDPR] Personal Data Export (WordPress 4.9.6+)
* New: [GDPR] Personal Data Erase (WordPress 4.9.6+)
* Update: Hook to decide whether to auto-generate a coupon or not
* Update: Hook to decide whether to show coupon as valid or invalid
* Update: Import-Export of coupon usage data
* Update: Minor CSS (Admin Send Store Credit tab)
* Update: POT file

2018.04.25 - version 3.4.1
* Fix: Import failing for CSV file which is exported from the plugin itself
* Fix: Serialized meta data is not copied correctly during Bulk Generate of coupons
* Update: Hook for adding meta during auto-generation of new coupon
* Update: POT File

2018.04.09 - version 3.4.0
* New: Storewide option to apply credit before/after tax
* Fix: Security Vulnerability (Thanks to: Matt Cohen)
* Fix: Loss of store credit discount when updating order from admin
* Fix: Store Credit not applying discount on taxes (WooCommerce AvaTax compatibility)
* Fix: Coupons that hit usage limit are not removed from My Account > Coupons
* Fix: Incorrect text when showing coupon's expiry (e.g. Expires in 1 days)
* Fix: Product categories, Exclude Product Categories & Customer Email not copying during duplication of coupon
* Fix: Correction in text displayed when searching coupon from admin
* Tweak: Reduced one loop to display coupon on My Account page
* Tweak: Showing & hiding Smart Coupons' field correctly
* Update: Moved Smart Coupons settings in new tab under WooCommerce > Settings
* Update: Added more settings related to Smart Coupons
* Update: Added image representation for some settings related to Smart Coupons
* Update: Minor CSS change to highlight fields coming from Smart Coupons plugin
* Update: Minor change in admin UI of "Bulk Generate" tab under WooCommerce > Coupons
* Update: Split "Import Coupons" from "Bulk Generate" to create a new tab "Import Coupons"
* Update: Importing of coupons will be handled from "Import Coupons" tab under WooCommerce > Coupons
* Update: Link WordPress Admin > Tools > Import > WooCommerce Coupons to "Import Coupons" tab under WooCommerce > Coupons
* Update: Revamp of "Send Store Credit" UI, added currency symbol, added validation, added TinyMCE editor for message
* Update: Introduction of "Preview Email" under WooCommerce > Coupons > Send Store Credit
* Update: Revamp of Import Coupons UI
* Update: Remove mapping fields & introduce file validation during import of coupons
* Update: Use of $wpdb->prepare for direct queries to database
* Update: sample.csv file, inclusion of subscription discount type
* Update: Added 'id' to emails getting sent from this plugin
* Update: Removed "Individual Use" settings from storewide settings of Smart Coupons
* Update: Introduction of "Invalid / Used Coupons" block on My Account > Coupons (hidden by default)
* Update: Provision to remove "Coupons" tab from My Account page
* Update: Minor correction in texts received via email with coupon
* Update: Export selected coupons
* Update: PHP Compatibility (version 5.3-7.1)
* Update: Added wpml-config.xml file
* Update: POT File
* Cleanup: Removed unrequired jQuery code & changes in method name related to removed fields
* Cleanup: Removed unused global $woocommerce
* Cleanup: Update of text domain in few old files

2018.03.12 - version 3.3.11
* Fix: Manual application of store credit to order (from admin panel) fails
* Fix: Call to member function 'get_applied_coupons' on null
* Update: Processing of Smart Coupons on more WooCommerce order statuses
* Update: POT File

2018.02.12 - version 3.3.10
* Fix: Store Credit/Gift Certificate not applying when order created from backend.

2018.01.31 - version 3.3.9
 * Fix: Broken order list page on admin side [WC 3.3]
 * Fix: Error: Call to member function 'get_id' on boolean
 * Fix: Some vulnerability
 * Tweak: Minor CSS change for responsiveness
 * Update: POT file

2017.10.28 - version 3.3.8
 * Fix: PHP Fatal error: Call to undefined method WC_Cart::get_coupon_discount_totals() (WooCommerce lower than 3.2.0)
 * Update: POT file

2017.10.16 - version 3.3.7
 * Update: Push "Purchase Credit amount" field, below product summary
 * Fix: PHP Notice:  Indirect modification of overloaded property WC_Cart::$coupon_discount_amounts has no effect (WooCommerce 3.0+)
 * Fix: PHP Notice: Undefined index: credit_called
 * Fix: Coupon is generated & sent on renewal even if it is set to "not send"
 * Fix: Fatal error: Uncaught Error: Class 'WC_Email' not found
 * Tweak: Added coupon code in email content such that it can be copied as text
 * Update: POT file

2017.09.11 - version 3.3.6
 * New: Allow use of store credit along with coupons which are Individual use coupons
 * Update: Added more parameters in call to wc_mail, to allow custom headers & attachments
 * Fix: Scheduled coupons won't display in the cart when published
 * Fix: Unnecessarily modifying recurring total when store credit is applied to cart which contains subscription
 * Fix: Order totals wrong when recalculation happens on order
 * Fix: Error on product object (Call to member function on boolean)
 * Fix: Bulk generation ignores excluded products
 * Fix: Unnecessarily loading list of coupons, resulting in additional load on page
 * Fix: Incorrect display of store credit amount in the order complete email when product is both virtual and downloadable
 * Fix: Illegal string offset
 * Fix: No coupons sent on purchasing a variable subscription
 * Update: POT file

2017.08.01 - version 3.3.5
 * Fix: Coupons not auto generating after purchase if order paid via coupon
 * Fix: Uncaught Error: Call to a member function get_used_coupons on boolean (compatibility with WooCommerce Subscriptions)
 * Fix: Conflict with Store Credit: Unable to use coupons if "delete after use" is enabled
 * Update: Support for discount types added by 3rd party plugins for auto-generation
 * Tweak: Turn sub-classes into Singleton classes (Thanks to: Matt Harrison)
 * Update: POT file

2017.06.30 - version 3.3.4
 * Fix: Broken meta fields for coupon on Bulk Generate Coupon page (WooCommerce 3.1+)
 * Fix: "Exclude sale items" restriction isn't being passed on to the generated coupon
 * Update: POT file

2017.06.01 - version 3.3.3
 * Fix: Coupon still shown on cart page even after applying it
 * Fix: Fatal errors when subscriptions are renewing
 * Fix: Coupons not generating sometimes
 * Update: Compatibility file for backward compatibility
 * Update: POT file

2017.05.26 - version 3.3.2
 * Fix: PHP Fatal error: Call to a member function get_quantity() on null

2017.05.25 - version 3.3.1
 * Fix: Incorrect expiry date for autogenerated coupons
 * Fix: No coupons sent on renewal of a subscription
 * Fix: Error when redeeming coupon from email link
 * Fix: Coupons not auto-generating after purchasing variations
 * Fix: Division By Zero error
 * Fix: Error in_array() expects parameter 2 to be array when redeeming coupon from email link
 * Fix: Full amount store credit (which is generated after purchasing credit) not issued (tax amount is deducted when "Price entered with tax" is set to "Yes")
 * Update: Added minified version of CSS
 * Update: POT file

2017.04.19 - version 3.3.0
 * New: WooCommerce 3.0+ compatibility
 * New: Use of PHP classes for different features (Distributed code from single file to multiple files)
 * New: Filter for setting coupon meta data for other types of coupon added by 3rd party plugins
 * Update: Will now support only WooCommerce 2.5+
 * Update: Formatted coupon label support for 3rd party plugins
 * Update: POT file

2017.03.31 - version 3.2.1
 * Fix: Discount added by store credit is not being passed to PayPal, if discount applied is more than cart item total
 * Fix: Coupons missing under "My Account" if product/category restriction present
 * Fix: Coupon not shown in email confirmation when paying for a Gift certificate with PayPal Express
 * Update: Limit number of coupons to show on cart, checkout & my-account page (Default: 5, can be modified using database or filter)
 * Update: Added currency symbol to price in "Total Credit Amount" in Coupons tab on My Account page
 * Update: CSS for "Total Credit Amount" in Coupons tab on My Account page
 * Update: POT file

2017.02.06 - version 3.2
 * New: Show Store Credit & other coupons separately on Coupons tab under My Account page (WooCommerce 2.6+)
 * New: Show total credit amount available to reedem on Coupons tab under My Account page (WooCommerce 2.6+)
 * Update: Do not show Coupon Received section on My Account page (can be changed via option - show_coupon_received_on_my_account)
 * Update: CSS tweaks for showing scroll bar on Cart & Checkout page for coupons
 * Update: POT file

2017.01.05 - version 3.1.9
 * Fix: Coupons sent in email is not applying when clicked
 * Fix: Coupon code applied via URL is not working sometimes
 * Update: POT file

2016.12.15 - version 3.1.8
 * Fix: Store Credit restricted to products or product categories not calculating the total correctly
 * Update: Email Subject line for store credit emails
 * Update: Grammatical correction in Send Store Credit form on checkout page (when sending to multiple people)
 * Update: POT file

2016.09.27 - version 3.1.7
 * Fix: Store Credit not applying discount

2016.09.19 - version 3.1.6
 * Fix: Store Credit, restricted to products or product categories, making cart/order total zero
 * Fix: Export existing coupon is not using correct delimiter in case of multiple products & product categories

2016.09.09 - version 3.1.5
 * Fix: Striping currency of products on shop page

2016.09.08 - version 3.1.4
 * Fix: Fatal error - Can't use method return value in write context

2016.09.07 - version 3.1.3
 * Fix: Coupon's field will not be displayed if there is no other field in General tab of Product data metabox (Thanks to: Remi Corson)
 * Fix: 1-click apply coupon is not working after quantity is updated in cart
 * Fix: 'Any amount' coupon product displays `free` when Memberships plugin is activated
 * Fix: Fatal error 'wc_help_tip' not defined (only for WooCommerce lower than 2.5)
 * Tweak: Remove tax information text from cart & order, when total is zero due to store credit

2016.07.18 - version 3.1.2
 * Fix: Sometimes Store Credit is discounting only 1 product in cart (store credit is restricted to be used on products & cart contains 3 line item of same variations)
 * Fix: Rounding totals of individual tax instead of rounding individual tax & then totaling, when store credit is applied to cart
 * Fix: 'Store Credit Used' alignment on order edit page
 * Fix: Sometimes product created to sell store credit showing as "Free"

2016.06.20 - version 3.1.1
 * Fix: Undefined index notice on My Account Page on WooCommerce 2.6.1
 * Fix: Absence of rounding in tax causing wrong discounting when 'Product' or 'Product category' is set in store credit

2016.06.16 - version 3.1
 * New: Tested up to WooCommerce 2.6
 * New: Coupons Tab under My Account page
 * New: Coupon layout on front end
 * Fix: Bulk generated storewide coupons not visible on cart, checkout & my account page
 * Update: Added compatibility files for WooCommerce 2.5 & WooCommerce 2.6
 * Update: POT file
 * Tweak: Changed content on Welcome page

2016.05.23 - version 3.0.17
 * Fix: Warning messages of 'subquery returning more than one row' when showing coupons on cart, checkout & my account page

2016.05.05 - version 3.0.16
 * Fix: Fatal error during activation "empty() only supports variables"
 * Fix: Send Store credit to others not working on checkout page

2016.05.03 - version 3.0.15
 * Fix: Related to the query optimization for showing coupons on cart, checkout & my account page
 * Update: Query optimization for store credit type coupons showing on cart, checkout & my account page

2016.04.27 - version 3.0.14
 * Fix: Related to the query optimization for showing coupons on cart, checkout & my account page

2016.04.27 - version 3.0.13
 * Fix: Remove usage of get_currentuserinfo() which is deprecated in WordPress 4.5
 * Fix: JavaScript error "unrecognized expression" when a coupon code containing special characters is applied
 * Update: Added filter to modify coupon URL in email
 * Update: Query optimization for showing coupons on cart, checkout & my account page

2016.03.18 - version 3.0.12
 * Fix: Fatal error: Call to a member function get() on a non-object in WooCommerce Subscriptions
 * Fix: View subscription showing empty page
 * Fix: Subscription list on admin side is broken
 * Fix: "Send store credit" giving fatal error & many PHP notices & warnings
 * Fix: Store Credit details sending in refunded order email as well
 * Update: Compatibility file for WooCommerce greater than equal to 2.4.0
 * Update: Minor update in style of "Send" button on "Send Store Credit" page

2016.03.11 - version 3.0.11
 * New: Support for sending WooCommerce core discount types to friends
 * New: Hook 'sc_generate_coupon_meta' to allow addition of coupon meta from 3rd party plugins
 * Fix: CSS tweaks for Bulk Generate tab
 * Fix: Store Credit are charged twice when user is registered from checkout page
 * Fix: Use store's date format to show expiry date of coupon
 * Fix: PHP Notice: Undefined index: QUERY_STRING
 * Fix: Errors when manually triggering a renewal using the subscriptions action scheduler
 * Fix: Auto generating coupon on subscription renewals even when it was set to not generate
 * Fix: On subscription renewals, auto generated coupons was sent to customer who placed that order
 * Update: Only add subscriptions filters when cart/order contains a subscription
 * Update: Compatibility with WooCommerce Subscription 2.0.10+
 * Update: POT file
 * Update: Tested with WooCommerce Subscription v2.0.11
 * Tweak: Welcome page content improvements
 * Tweak: Minor change in handling URL arguments
 * Tweak: Set renewal order status, when auto paid via store credit, to processing, only when order needs processing

2016.01.25 - version 3.0.10
 * Fix: Fatal error: Call to undefined method WC_Subscriptions_Coupon::increase_coupon_discount_amount for WooCommerce Subscription lower than 2.0
 * Update: Tested up to WooCommerce 2.5

2015.12.15 - version 3.0.9
 * Fix: "Send Store Credit" not generating coupon
 * Fix: Coupons sent via email, sometimes showing only "Never Expires"

2015.12.08 - version 3.0.8
 * Fix: Store Credit applying in cart but not reducing order total

2015.12.07 - version 3.0.7
 * New: Compatibility with WooCommerce Subscription 2.0+
 * Fix: Fatal error due to undefined function 'wc_get_price_decimal_separator'
 * Fix: Email sent after coupon generated via shortcode is always showing 'store credit' even if it is other discount type
 * Fix: Coupon applied through URL, redirecting to cart by default, resulting in removal of coupon from cart
 * Fix: Coupon applied thorugh URL, not carry forwarding other query params
 * Fix: Increasing store credit's amount when order is cancelled before payment
 * Update: Additional setting for `smart_coupon` shortcode to control number of coupons to be generated on page reload
 * Tweak: Made some variables accessible to remove PHP notices

2015.10.17 - version 3.0.6
 * Fix: PHP warning "html_entity_decode() expects parameter 1 to be string" in "Store Credit Receiver Detail" form on checkout page
 * Fix: Store Credit having 'Usage Restriction' on products & categories, was giving more than allowed discount
 * Fix: Remove PHP notices from "Bulk Generate / Import Coupons" admin page
 * Fix: Unnecessary notice "Coupon Removed" from cart & checkout page
 * Fix: Duplicate amount deduction from store credit when WooCommerce Multilingual is active (Thanks to: Permanyer)
 * Fix: A coupon offering only "Free Shipping" are not being auto-generated & send via email from "Bulk Generate Coupons" method.
 * Fix: WooCommerce core coupons are not auto-generating when associated with a product along with store credit
 * Update: Setting to switch on / switch off, sending of emails from Smart Coupons
 * Update: POT file
 * Tweak: Remove a line of code which was unnecessarily creating instance of WP_Query, affecting performance of the plugin (Thanks to: Lindsay Hemric)
 * Tweak: Showing "Free Shipping" information, if applicable, in coupons displayed on cart, checkout & my account page
 * Tweak: Show information about "Free Shipping", if applicable, in email content header

2015.09.22 - version 3.0.5
 * Fix: Show 'Discount' & 'Store Credit Used' separately
 * Fix: Store Credit amount in description for attached coupons are not changing per variations
 * Fix: Store Credit not applying when subscription sign-up fee is zero, due to this Store Credit can't be used for auto-renewal payment
 * Fix: Coupon's description is not copied to auto generated coupons
 * Fix: 'Free Gift' coupons are not displayed on checkout page (Thanks to: Kathy)
 * Update: Allow attaching of coupons to all WooCommerce product types
 * Tweak: Replaced 'woocommerce_price' with compatibility function for price
 * Tweak: Minor change in compatibility file

2015.08.14 - version 3.0.4
 * Fix: Issuing more store credit when purchasing store credit in multiple quantities

2015.08.13 - version 3.0.3
 * Fix: Incorrect placeholder for coupon in product edit screen
 * Fix: Showing empty round bracket '()' if currency symbol is hidden, on 'Purchase Credit' page
 * Fix: 'woocommerce_admin is not defined' while bulk generating coupons
 * Fix: Missing text domain in few places
 * Update: Updated POT file

2015.07.16 - version 3.0.2
 * Update: Show a notice about important setting related to store credit

2015.07.15 - version 3.0.1
 * Update: Change of Text Domain & Language loader (Thanks to: Nicola Mustone)
 * Update: More details in displayed coupons (Thanks to: Doug Smith)
 * Update: Refunding or cancelling an order were not restoring credit amounts back to coupons, which was used in the order
 * Fix: Only recently received coupons are visible under 'Coupons Received' on My Account page

2015.06.18 - version 3.0
 * Fix: When applying discounts for store credit, usage restrictions related to product & product categories was not considered (Thanks to: Steven Taumoepeau)
 * Update: Use of WooCommerce Coupon's meta box for displaying coupon data fields under 'Bulk Generate Coupons'
 * Update: Remove process of combining similar coupons
 * Update: Added POT file for translation
 * Tweak: Limit height of 'Available coupons' on cart, checkout & my account page, and make it scrollable
 * Tweak: Limit height of 'Coupons Received' on my account page & 'Coupons Sent' on order admin page. Additionally make it scrollable
 * Tweak: Removed admin menu 'Smart Coupons', can now be accessed from 'Coupons'
 * Tweak: By default, hide associated coupon details on product page

2015.05.20 - version 2.9
 * New: Support for auto-debit from store credit in subscription renewals, when the store credit is applied during sign-up / first purchase of subscription
 * New: Welcome page with features & faqs
 * Fix: Don't copy meta '_used_by' after duplicating coupon
 * Fix: Not passing discounts added by store credit to PayPal & Mijireh
 * Fix: $order->get_total_discount() returns zero when store credit used in order
 * Fix: CSS of Smart Coupons conflicting with CSS of other post_types
 * Fix: Smart Coupon's CSS file added on unrequired admin pages, causing broken fields from other plugins
 * Update: Don't show friend's coupons to sender
 * Update: Instead of deleting fully used store credit, trash it, so that it can be retrieved later, if required

2015.04.09 - version 2.8.6
 * Fix: Incorrect discount calculation when store credit applied along with other discount type in cart

2015.03.27 - version 2.8.5
 * Fix: Missing text domains at some places
 * Fix: Product which allows to purchase store credit doesn't show currency symbol
 * Fix: PHP Warning: Illegal string offset 'coupon_type'
 * Fix: Replaced 'isset' with 'empty' as 'isset' was giving Fatal Error
 * Update: Allow filtered export
 * Update: Added styles for coupon code with additional details which is sent after coupon generation via email
 * Update: Access to Smart Coupons' feature from WooCommerce Coupon page
 * Update: Added new fields for coupon in import
 * Update: Added label for store credit, to be displayed in cart or order
 * Update: Replace 'type' with 'discount_type'. Look for discount_type in key 'discount_type' instead of 'type'

2015.03.17 - version 2.8.4
 * Fix: Broken 'Set featured image' due to undefined 'wc_select_params'

2015.03.06 - version 2.8.3
 * Fix: Credit should be applied after shipping & taxation
 * Fix: Smart Coupon balance not updating correctly
 * Fix: Usage limit data of coupon was not added when auto generating coupons
 * Fix: Sometimes not generating unique coupon codes
 * Fix: Unnecessary coupon notices related to Store Credit on cart & checkout page, when Store Credit's balance is zero
 * Fix: 'One click apply coupon' not working from My Account page (WooCommerce 2.3.x)

2015.02.13 - version 2.8.2
 * Fix: Conflict with discount of WooCommerce core coupons

2015.02.11 - version 2.8.1
 * Fix: 'One click apply coupon' not working (WooCommerce 2.2)
 * Update: Minor update in coupon notice & javascript for applying coupon

2015.02.10 - version 2.8
 * Update: WooCommerce 2.3 compatible
 * Update: Discount calculation for Smart Coupons
 * Fix: Few fields of coupon was not added when auto generating coupons
 * Fix: Emails not sending when bulk generating & importing coupons and when 'Disable Email Resriction' is checked

2015.02.02 - version 2.7
 * Fix: Conflict with 'Product CSV Import Suite'
 * Fix: Customer email was adding via Import, even if 'Disable Email Restriction' was checked
 * Fix: Coupon displayed via shortcode always show discount type as 'Store Credit' for all discount type
 * Fix: Email subject always show coupon, even if Store Credit is sent
 * Fix: 'Coupons received' details not coming up in order complete email for customer
 * Fix: 'Coupons received' on My Account page shows trashed coupons
 * New: Template for purchasing 'Credit of any amount'
 * Update: Allowed searching of all discount type, when adding Smart Coupons shortcode from WordPress editor
 * Update: Support for template path 'woocommerce/woocommerce-smart-coupons/email.php' in addition to 'woocommerce-smart-coupons/email.php' and 'email.php'
 * Update: More fields for discount type 'Store Credit / Gift Certificate' on coupon edit page
 * Update: Made meta data protected which are added from Smart Coupons
 * Update: By default, uncheck, 'Delete Gift / Credit' in Smart Coupons Storewide setting at WooCommerce -> Settings

2014.12.23 - version 2.6.2
 * Fix: Smart Coupons shortcode button's incorrect allignement (Thanks to: Kevin Hagerty)
 * Fix: Minor update in style of "coupon shortcode form" to display it on top-most layer
 * Fix: "Gift store credit to someone else" not working, generated coupons are getting send to sender
 * Fix: Discount amount of store credit not visible in cart after applying

2014.12.03 - version 2.6.1
 * Fix: "Store Credit Receiver Details" form not showing email & message fields
 * Fix: Showing "Invalid email error" even after entering a valid email address in "Store Credit Receiver Details" form

2014.10.31 - version 2.6
 * Update: Performance improvement by query optimization
 * Fix: Unnecessary loading of JavaScript on front-end
 * Fix: Some fields of coupons not importing

2014.10.04 - version 2.5
 * Fix: Coupon code in URL not working properly with Add to cart in URL
 * Fix: After applying store credit, discounts are applying on renewals also
 * Update: Show spinner on clicked coupon when it is being applied to cart

2014.09.09 - version 2.4
 * Update: WooCommerce 2.2 compatible
 * Update: Docblocks & Indentation
 * Fix: Minor CSS fix

2014.08.23 - version 2.3
 * Fix: Conflict with PDF Invoice plugin
 * Fix: Apply coupon on cart redirect to home page in some cases
 * Fix: Shortcode query related bug
 * Fix: All coupons shows up for logged in user with no email address set
 * Update: All new coupon meta fields available for import and export functionality

2014.07.16 - version 2.2.2
 * Fix: "Apply coupon by one click" conflict with different version of IE
 * Fix: Unnecessary "No records found" in email

2014.05.27 - version 2.2.1
 * Fix: Localization for javascript error message
 * Fix: Plugin's name was hardcoded
 * Fix: Smart Coupon shortcode: Fixes related to JavaScript errors & changed icon for button

2014.05.02 - version 2.2
 * Update: Message field for sending credit from admin

2014.04.14 - version 2.1.3
 * Fix: Minor fix related to misssing global $woocommerce

2014.03.27 - version 2.1.2
 * Fix: Unnecessary "No records found" in email

2014.03.25 - version 2.1.1
 * Fix: Gift certificate email not sent with special characters in subject
 * Fix: Unnecessary "No records found" on My Account page
 * Fix: Unnecessary warnings in email

2014.03.11 - version 2.1
 * Fix: Upper case in coupon code causes "Coupon does not exist!" error
 * Fix: Addition of 'coupon_sent' meta in all orders
 * New: Feature to show coupon sent / received to store admin / customer
 * New: Filter to allow export of more coupon's field (custom meta)
 * Update: Included new coupon field (added in WC 2.1+) in export

2014.01.23 - version 2.0
 * Update: WooCommerce 2.1 compatibility
 * Fix: Incorrect coupon generation
 * Update: Other minor fixes related to PHP warnings.

2014.01.08 - version 1.6.5
 * Fix: Additional space in email's subject
 * Update: Support for overriding email template of Smart Coupons

2013.12.21 - version 1.6.4
 * New: Coupon code send via email are URL Coupon link (Integration with WooCommerce URL Coupons)

2013.12.07 - version 1.6.3
 * Update: Notification for undefined function 'mb_detect_encoding' for preventing fatal error
 * Fix: Coupons generating 2 times in some cases

2013.12.03 - version 1.6.2
 * Fix: 'Add to cart' from catalog page redirecting to that product's shop page
 * Update: Show 'Free Shipping coupon' on Cart / Checkout page

2013.11.29 - version 1.6.1
 * Fix: Empty receiver's email address in acknowledgement email to sender
 * Fix: PHP warnings

2013.11.15 - version 1.6
 * Fix: Coupons not generating for product having price zero
 * Fix: Warnings for BC Math module of PHP
 * Fix: Warnings for incorrect line ending while importing coupons
 * Fix: Warnings on shop page when showing coupons using shortcode
 * Update: Added buttons for products which are used to sell credits on shop archive page
 * Update: Additional field in coupons to make it visible on cart / checkout to everyone
 * Update: Additional field to prevent addition of emails in 'Email restriction' field of coupons
 * New: Option to allow recursive coupon generation along with subscription renewal order (by default coupon generation on renewal order is disabled)

2013.09.12 - version 1.5.1
 * Fix: Change CSS code to remove conflict with other wordpress elements
 * Fix: Sometimes failed to add store credit / gift certificate in cart
 * Fix: Unwanted 'console.debug' was breaking functionality in IE10
 * Fix: Removed unwanted field from coupon configuration if it is Store Credit

2013.09.01 - version 1.5
 * Fix: Coupons & emails are not getting generated in few cases
 * New: Coupon can be applied from My Account page or from URL query string [coupon-code=coupon_name]
 * New: Generated coupon's details like - coupon code, receiver email & messages are saved in order meta 'sc_coupon_receiver_details'
 * Update: Allow addition of different Store Credit amount in same order
 * Update: Changes in Store Credit Receiver Details form layout
 * Update: Changes in Coupon shortcode popup window
 * Update: Separate message field for each e-mail address on Store Credit Receiver Detail form
 * Update: Coupons can be associated with product_type 'subscription' & 'variable subscription'
 * Update: Changes in email content to be sent
 * Update: Minor change in showing expiry date of coupons
 * Update: Don't show expired coupons

2013.08.08 - version 1.4.2
 * Fix: PHP Warning

2013.08.02 - version 1.4.1
 * Fix: 'Add to cart' not working after page says 'Invalid amount'

2013.08.01 - version 1.4
 * Fix: Credit amount picking up price of product, even if it is not set
 * Fix: Show Coupon's field only for simple & variable products, on products edit page
 * New: Shortcode [smart_coupons]
 * New: Style of coupons display on Cart, Checkout and My Account pages
 * New: CSS Classes to change style of coupons

2013.07.29 - version 1.3.2
* Update: Validation before purchase of credit amount
* Update: Changed credit field from 'text field' to 'number field'
* Update: Hide unnecessary text from product shop page if coupon is invalid

2013.07.26 - version 1.3.1
* Fix: Issue with localization

2013.07.12 - version 1.3
 * New: Field for setting expiry date of coupon in days, weeks, months & years
 * Update: Support for adding many manual store credit / gift certificate in same

2013.05.17 - version 1.2.9.1
 * Fix: PHP Warning: Invalid argument for foreach

2013.05.13 - version 1.2.9
 * New: More data fields for generation & import of coupons
 * New: Option to e-mail coupon's code to respective customers while importing coupons
 * New: Option to set/modify texts from Smart Coupons to be displayed on front end
 * Update: Option to prevent addition of emails through Smart Coupons in 'E-mail Restriction' field of coupons

2013.05.01 - version 1.2.8.7
 * Update: Converted all front end javascript to inline javascript using 'add_inline_js' of WC object

2013.04.29 - version 1.2.8.6
 * Update: Location of 'Gift Certificate Receiver Detail Form' on Checkout page
 * Update: Included text 'Purchase credit worth' in HTML element

2013.04.24 - version 1.2.8.5
 * Fix: Changed hook for displaying "Store Credit detail" form
 * Fix: Changing 'customer_email' field of coupon on 'Profile' update

2013.04.20 - version 1.2.8.4
 * Fix: Export coupon failing when site name is a URL

2013.03.19 - version 1.2.8.3
 * Fix: Fatal error of 'Call to undefined function str_getcsv()' for PHP version lower than 5.3
 * Update: Display all available coupons on 'My Account' page instead of showing just 'Store Credit'

2013.03.11 - version 1.2.8.2
 * Fix: Fatal error of "Cannot re-assign auto-global variable _POST"

2013.02.28 - version 1.2.8.1
 * Fix: Store Credit getting sent multiple times on order status change

2013.02.28 - version 1.2.8
 * Fix: For errors while importing coupons having same coupon code
 * New: Bulk generation of coupons. Either export them in CSV file or directly import
 * New: Export coupons list from store which can be used for importing also.
 * New: Support for PayPal Express Checkout
 * Update: 'Send Store Credit' feature now supports sending of bulk Store Credit to multiple e-mail ids (comma separated) at one go

2013.02.22 - version 1.2.7.1
 * Fix: 'Minimum amount' field of coupon was not considered in generation/creation of another coupon
 * Text Changes

2013.02.12 - version 1.2.7
 * Fix: Fatal error, when sending invoice of order (on which coupons are applied) to customer's e-mail

2013.01.30 - version 1.2.6
 * Update: Compatible version for both WooCommerce 1.6.6 & 2.0.0
 * Fix: Customer not getting full usage of the coupon which they have received after purchasing multiple quantities of the product

2012.12.27 - version 1.2.5
 * Fix: Products configured for 'Store Credit of any amount' was getting added with price zero, when it was getting added from Catalog/Shop page

2012.12.19 - version 1.2.4
 * Fix for notices

2012.12.10 - version 1.2.3
 * Fix: Store Credit once applied, is not getting removed
 * Fix: Unable to bring coupon's list in auto-complete text-field, when associating coupons to product
 * Fix: Store Credit / Gift Certificate is added to cart with price zero

2012.12.04 - version 1.2.2
 * New updater

2012.11.20 - version 1.2.1
 * Updated: Better localisation compatibility for the plugin - separate text domain
 * Updated: Currency symbol added when user enters the amount for a gift certificate of any denomination

2012.11.19 - version 1.2
 * New: Allow purchasing gift certificates / store credits of any denomination
  (compatible with "WooCommerce Name Your Price" plugin too)
 * New: Feature to Send Store Credit / Gift Certificate to multiple people
 * New: Additional setting to change subject of E-mail containing Coupon Codes
 * Removed: "Apply Before Tax" option for Store Credit / Gift Certificate
 * Updated: URL for store that is included in e-mails
 * Fix: Expiry date of generated coupons getting set to 1970


2012.10.19 - version 1.1.1
 * Small case change

2012.10.11 - version 1.1
 * New: Bulk Import for Coupons
 * New: Automatic Generation of Coupons
 * New: Support for adding prefix & suffix to automatically generated coupons
 * New: "Duplicate Coupon"
 * New: Send Store Credit / Gift Certificate
 * New: Support for searching a coupon using Customer's e-mail address
 * Updated: Notify customer about balance remaining in Store Credit / Gift Certificate in "Order Completed" e-mail
 * Updated: Link to the store is included in e-mails
 * Fixed: "Order stays in processing state & never completes" problem


2012.08.07 - version 1.0
 * First release
